#if !defined(SUPER_NEW)
#define SUPER_NEW "New Character"
#endif
#if !defined(SUPER_LOAD)
#define SUPER_LOAD "Load Character"
#endif
#if !defined(SUPER_QUIT)
#define SUPER_QUIT "Quit"
#endif

mob/var/save_file_1 = 0
mob/var/save_file_2 = 0
mob/var/save_file_3 = 0
var/list/Name = list()

var/list/HTML_TAGS = list ("<",">")
mob/proc/Check_For_Tagilitys(T as text,var/list/L)
	for(var/V in L)
		if(findtext(T,V))
			return TRUE

var/list/NUM_TAGS = list ("1","2","3","4","5","6","7","8","9","0")
mob/proc/Check_For_Nums(T as text,var/list/L)
	for(var/V in L)
		if(findtext(T,V))
			return TRUE

var/list/SYM_TAGS = list ("!","@","#","$","%","^","&","*","(",")","-","_","+","=","(",")","{","}",";",":","'","<",">",",",".","?","/","[","]")
mob/proc/Check_For_Syms(T as text,var/list/L)
	for(var/V in L)
		if(findtext(T,V))
			return TRUE

mob/Guest
	Login()
		src.verbs -= new/mob/verb/OOC
		src.verbs -= new/mob/verb/Say

		if(src.client.key == "Guest") //Here's the line's to stop the Runtime Error - Fixed by Hant Teath
			del(src.client)

//		if(src.client.byond_version < 349)
//			src << "\red You BYOND Version: [src.client.byond_version] is out of Date! Please upgrade to the latest Version: 348!"
//			del(src.client)

		src.loc = locate(87,6,3)

		Start

		switch(alert("Welcome to Dragonball: Rebirth","Dragonball: Rebirth","New Character","Load Character","Delete Character"))

			if("New Character")
				switch(alert("Which Slot do you wish to Select?","","Slot 1","Slot 2","Slot 3"))

					if("Slot 1")
						if(fexists("Player Saves/[src.client.ckey]/Save File 1.sav"))
							switch(alert("You already have a Character on Slot 1. Overwrite it?","","Yes","No"))
								if("Yes")
									fdel("Player Saves/[src.client.ckey]/Save File 1.sav")
									src.save_file_1 = 1
									Create()
								else
									goto Start
									return
						else
							src.save_file_1 = 1
							Create()
					if("Slot 2")
						if(fexists("Player Saves/[src.client.ckey]/Save File 2.sav"))
							switch(alert("You already have a Character on Slot 2. Overwrite it?","","Yes","No"))
								if("Yes")
									fdel("Player Saves/[src.client.ckey]/Save File 2.sav")
									src.save_file_2 = 1
									Create()
								else
									goto Start
									return
						else
							src.save_file_2 = 1
							Create()
					if("Slot 3")
						if(fexists("Player Saves/[src.client.ckey]/Save File 3.sav"))
							switch(alert("You already have a Character on Slot 3. Overwrite it?","","Yes","No"))
								if("Yes")
									fdel("Player Saves/[src.client.ckey]/Save File 3.sav")
									src.save_file_3 = 1
									Create()
								else
									goto Start
									return
						else
							src.save_file_3 = 1
							Create()

			if("Load Character")
				switch(alert("Which Slot do you wish to Select?","","Slot 1","Slot 2","Slot 3"))

					if("Slot 1")
						if(fexists("Player Saves/[src.client.ckey]/Save File 1.sav"))
							usr.save_file_1 = 1
							usr.client.Load()
						else
							alert("No Saved File Found!")
							sleep(5)
							goto Start
							return
					if("Slot 2")
						if(fexists("Player Saves/[src.client.ckey]/Save File 2.sav"))
							usr.save_file_2 = 1
							usr.client.Load()
						else
							alert("No Saved File Found!")
							sleep(5)
							goto Start
							return
					if("Slot 3")
						if(fexists("Player Saves/[src.client.ckey]/Save File 3.sav"))
							usr.save_file_3 = 1
							usr.client.Load()
						else
							alert("No Saved File Found!")
							sleep(5)
							goto Start
							return

			if("Delete Character")
				var/del_name = ""
				switch(alert("Which Slot do you wish to Delete?","","Slot 1","Slot 2","Slot 3"))

					if("Slot 1")
						switch(alert("Are you Sure?","","Yes","No"))
							if("Yes")
								if(fexists("Player Saves/[src.client.ckey]/Save File 1.sav"))
									var/savefile/Load = new("Player Saves/[src.client.ckey]/Save File 1.sav")
									Load["name"] >> del_name
									var/savefile/N = new("World Save Files/Player Names.sav")
									Name.Remove(ckey(del_name))
									N["Name"] << Name
									fdel("Player Saves/[src.client.ckey]/Save File 1.sav")
									goto Start
								else
									alert("No Saved File Found!")
									sleep(5)
									goto Start
							else
								goto Start
								return
					if("Slot 2")
						switch(alert("Are you Sure?","","Yes","No"))
							if("Yes")
								if(fexists("Player Saves/[src.client.ckey]/Save File 2.sav"))
									var/savefile/Load = new("Player Saves/[src.client.ckey]/Save File 2.sav")
									Load["name"] >> del_name
									var/savefile/N = new("World Save Files/Player Names.sav")
									Name.Remove(ckey(del_name))
									N["Name"] << Name
									fdel("Player Saves/[src.client.ckey]/Save File 2.sav")
								else
									alert("No Saved File Found!")
									sleep(5)
									goto Start
							else
								goto Start
								return
					if("Slot 3")
						switch(alert("Are you Sure?","","Yes","No"))
							if("Yes")
								if(fexists("Player Saves/[src.client.ckey]/Save File 3.sav"))
									var/savefile/Load = new("Player Saves/[src.client.ckey]/Save File 3.sav")
									Load["name"] >> del_name
									var/savefile/N = new("World Save Files/Player Names.sav")
									Name.Remove(ckey(del_name))
									N["Name"] << Name
									fdel("Player Saves/[src.client.ckey]/Save File 3.sav")
								else
									alert("No Saved File Found!")
									sleep(10)
									goto Start
							else
								goto Start
								return
		..()

	proc
		Create()
			var/mob/mobcreation
			var/newname = null
			var/config = "065-090&097-122&095&032"

			while(!asciifilter(newname,config)||newname == null)newname = input("Pick Character Name","Name",src.key) as text

			if(ckey(newname) in Name)
				alert("This name is already in use. Try again please,")
				Create()

			if(lentext(newname) > 25)
				alert("Your name can not exceed 25 characters.")
				Create()

			if(isnull(newname) | newname == "" | !newname)
				alert("Your name may not be blank.")
				Create()

			if(Check_For_Tagilitys(newname,HTML_TAGS) == TRUE)
				alert("Your name may not have tagilitys of html in it.")
				Create()

			if(Check_For_Nums(newname,NUM_TAGS) == TRUE)
				alert("Your name may not have numbers in it.")
				Create()

			if(Check_For_Syms(newname,SYM_TAGS) == TRUE)
				alert("Your name may not have symbols in it.")
				Create()

			else

				newname = html_encode(newname)
				var/race = input("What were you born as?","Choose a Birth Race") in list ("Bio-Android","Changling","Half Saiyan","Human","Majin","Namek","Saiyan","Tuffle","Demon","Android","SaibaMan","HFILGuy")
				switch(race)

					if("Namek")
						mobcreation = new /mob/PC()
						mobcreation.race = "Namek"
						mobcreation.icon = 'Namek - Normal.dmi'
						mobcreation.ki = 150
						mobcreation.ki_max = 150
						mobcreation.defence = 15
						mobcreation.defence_max = 15
						mobcreation.contents += new/obj/Techniques/Regenerate
						mobcreation.contents += new/obj/Transform/Transform
						mobcreation.Karma()

					if("HFILGuy")
						mobcreation = new /mob/PC()
						mobcreation.race = "HFILGuy"
						mobcreation.icon = 'HFIL Guy.dmi'
						mobcreation.ki = 150
						mobcreation.ki_max = 150
						mobcreation.defence = 15
						mobcreation.defence_max = 15
						mobcreation.contents += new/obj/Techniques/Regenerate
						mobcreation.contents += new/obj/Transform/Transform
						mobcreation.Karma()

					if("SaibaMan")
						mobcreation = new /mob/PC()
						mobcreation.race = "SaibaMan"
						mobcreation.icon = 'GreenSaibamen.dmi'
						mobcreation.ki = 150
						mobcreation.ki_max = 150
						mobcreation.defence = 15
						mobcreation.defence_max = 15
						mobcreation.contents += new/obj/Techniques/Regenerate
						mobcreation.contents += new/obj/Transform/Transform
						mobcreation.Karma()

					if("Demon")
						mobcreation = new /mob/PC()
						mobcreation.race = "Demon"
						mobcreation.icon = 'Demon.dmi'
						mobcreation.powerlevel = 80000
						mobcreation.powerlevel_max = 80000
						mobcreation.ki = 60000
						mobcreation.ki_max = 60000
						mobcreation.defence = 60000
						mobcreation.defence_max = 70000
						mobcreation.contents += new/obj/Techniques/Regenerate
						mobcreation.contents += new/obj/Transform/Transform
						mobcreation.Karma()

					if("Majin")
						mobcreation = new /mob/PC()
						mobcreation.race = "Majin"
						mobcreation.icon = 'Majin - Form 1.dmi'
						mobcreation.karma = "Evil"
						mobcreation.powerlevel = 150
						mobcreation.powerlevel_max = 150
						mobcreation.strength = 15
						mobcreation.strength_max = 15
						mobcreation.contents += new/obj/Techniques/Majin/Regenerate
						mobcreation.contents += new/obj/Transform/Transform

					if("Changling")
						mobcreation = new /mob/PC()
						mobcreation.race = "Changling"
						mobcreation.icon = 'Changling - Form 1.dmi'
						mobcreation.karma = "Evil"
						mobcreation.powerlevel = 250
						mobcreation.powerlevel_max = 250
						mobcreation.strength = 10
						mobcreation.strength_max = 10
						mobcreation.contents += new/obj/Transform/Transform
						mobcreation.contents += new/obj/Transform/Revert

					if("Saiyan")
						mobcreation = new /mob/PC()
						if(prob(50))
							mobcreation.rage_chromosome = 1
						else
							mobcreation.train_chromosome = 1
						mobcreation.race = "Saiyan"
						mobcreation.powerlevel = 200
						mobcreation.powerlevel_max = 200
						mobcreation.strength = 15
						mobcreation.strength_max = 15
						mobcreation.overlays += tail
						mobcreation.Skin()
						mobcreation.Hair()
						mobcreation.Karma()

					if("Tuffle")
						mobcreation = new /mob/PC()
						mobcreation.race = "Tuffle"
						mobcreation.icon = 'Bebi - Form 1.dmi'
						mobcreation.karma = "Evil"
						mobcreation.powerlevel = 300
						mobcreation.powerlevel_max = 300
						mobcreation.upkeep = 5
						mobcreation.contents += new/obj/Techniques/Tuffle/Absorb

					if("Bio-Android")
						mobcreation = new /mob/PC()
						mobcreation.race = "Bio-Android"
						mobcreation.icon = 'Bio Android - Form 1.dmi'
						mobcreation.karma = "Evil"
						mobcreation.powerlevel = 175
						mobcreation.powerlevel_max = 175
						mobcreation.upkeep = 5
						mobcreation.contents += new/obj/Techniques/Bio_Android/Absorb
						mobcreation.contents += new/obj/Transform/Transform
						mobcreation.contents += new/obj/Transform/Revert

					if("Android")
						mobcreation = new /mob/PC()
						mobcreation.race = "Android"
						mobcreation.karma = "Evil"
						mobcreation.powerlevel = 250
						mobcreation.powerlevel_max = 250
						mobcreation.verbs += new/mob/learn/verb/Ki_Absorb
						mobcreation.verbs += new/mob/learn/verb/Scan
						mobcreation.verbs += new/mob/learn/verb/Self_Destruct
						mobcreation.learn_absorb = 1
						mobcreation.learn_scan = 1
						mobcreation.learn_selfdestruct = 1
						mobcreation.Skin()
						mobcreation.Hair()

					if("Half Saiyan")
						mobcreation = new /mob/PC()
						mobcreation.contents += new/obj/Transform/Transform
						mobcreation.contents += new/obj/Transform/Revert
						mobcreation.race = "Half Saiyan"
						mobcreation.powerlevel = 150
						mobcreation.powerlevel_max = 150
						mobcreation.strength = 10
						mobcreation.strength_max = 10
						mobcreation.defence = 10
						mobcreation.defence_max = 10
						mobcreation.Skin()
						mobcreation.Hair()
						mobcreation.Karma()

					if("Human")
						mobcreation = new /mob/PC()
						mobcreation.race = "Human"
						mobcreation.contents += new/obj/Transform/Transform
						mobcreation.contents += new/obj/Transform/Revert
						mobcreation.ki = 75
						mobcreation.ki_max = 75
						mobcreation.strength = 15
						mobcreation.strength_max = 15
						mobcreation.defence = 15
						mobcreation.defence_max = 15
						mobcreation.Skin()
						mobcreation.Hair()
						mobcreation.Karma()

				if(client.IsByondMember())
					mobcreation.level = 50
					mobcreation.powerlevel = 175000
					mobcreation.powerlevel_max = 175000
					mobcreation.ki = 150000
					mobcreation.ki_max = 150000
					mobcreation.strength = 50000
					mobcreation.strength_max = 50000
					mobcreation.defence = 50000
					mobcreation.defence_max = 50000
					mobcreation.zenni = 75000

				mobcreation.energy_code = rand(0000001,9999999)
				mobcreation.it_blocked = 1
				mobcreation.loc = locate(62,25,1)
				mobcreation.name = newname

				if(src.save_file_1)
					mobcreation.save_file_1 = 1
				if(src.save_file_2)
					mobcreation.save_file_2 = 1
				if(src.save_file_3)
					mobcreation.save_file_3 = 1

				var/savefile/N = new("World Save Files/Player Names.sav")
				Name.Add(ckey(mobcreation.name))
				N["Name"] << Name

				world << "<font color = #F9DB13>Client Information: <font color = white>Everyone welcome our newest Player: [mobcreation.name] the [mobcreation.race]!"

				src.client.mob = mobcreation
				del(src)