//-- GM's / Admins / Moderators / Police --

//-- Level 1 GM --
var/const/L1_GM1 =""
var/const/L1_GM2 =""
var/const/L1_GM3 =""
var/const/L1_GM4 =""
var/const/L1_GM5 =""

//-- Level 2 GM --
var/const/L2_GM1 = ""
var/const/L2_GM2 = ""
var/const/L2_GM3 = ""
var/const/L2_GM4 = ""
var/const/L2_GM5 = ""

//-- Level 3 GM --
var/const/L3_GM1 = ""
var/const/L3_GM2 = ""
var/const/L3_GM3 = "Pr_realist"
var/const/L3_GM4 = "Tyg13"
var/const/L3_GM5 = "Magical Hero"

//-- Level 4 GM --
var/const/L4_GM1 = "Aurora_Twilight"
var/const/L4_GM2 = "Trunksssj005"
var/const/L4_GM3 = "Kupo Winters"
var/const/L4_GM4 = "Xgostbewear"
var/const/L4_GM5 = "Cardgamemaster8"

//-- Level 5 GM --
var/const/L5_GM1 = ""
var/const/L5_GM2 = ""
var/const/L5_GM3 = ""
var/const/L5_GM4 = "GUSTEY"
var/const/L5_GM5 = "Galick2"

//-- Lists --

var/list/Banned_Key = list()
var/list/Banned_IP = list()

var/list/H_L1_GM = list()
var/list/H_L2_GM = list()
var/list/H_L3_GM = list()
var/list/H_L4_GM = list()
var/list/H_L5_GM = list()

var/World_Mute = 0

mob/var/GM_Level = 0
mob/var/GM_Muted = 0



//-- Load GM Verbs Proc --

mob/proc/Check_GM()
	if(key == L1_GM1 || key == L1_GM2 || key == L1_GM3 || key == L1_GM4 || key == L1_GM5)
		GM_Level = 1
		title = "\yellow Low Enforcer"
		Apply_GM()
	if(key == L2_GM1 || key == L2_GM2 || key == L2_GM3 || key == L2_GM4 || key == L2_GM5)
		GM_Level = 2
		title = "\blue Medium Enforcer"
		Apply_GM()
	if(key == L3_GM1 || key == L3_GM2 || key == L3_GM3 || key == L3_GM4 || key == L3_GM5)
		GM_Level = 3
		title = "\red High Enforcer"
		Apply_GM()
	if(key == L4_GM1 || key == L4_GM2 || key == L4_GM3 || key == L4_GM4 || key == L4_GM5)
		GM_Level = 4
		title = "<font color = #FFAE00>Master Enforcer"
		Apply_GM()
	if(key == L5_GM1 || key == L5_GM2 || key == L5_GM3 || key == L5_GM4 || key == L5_GM5)
		GM_Level = 5
		title = "<font color = #00A691>Game Owner"
		Apply_GM()

	if(key in H_L1_GM)
		GM_Level = 1
		Apply_GM()
	if(key in H_L2_GM)
		GM_Level = 2
		Apply_GM()
	if(key in H_L3_GM)
		GM_Level = 3
		Apply_GM()
	if(key in H_L4_GM)
		GM_Level = 4
		Apply_GM()
	if(key in H_L5_GM)
		GM_Level = 5
		Apply_GM()

mob/proc/Apply_GM()
	if(GM_Level >= 1)
		src.verbs += typesof(/mob/System/L1_GM/verb)
	if(GM_Level >= 2)
		src.verbs += typesof(/mob/System/L2_GM/verb)
	if(GM_Level >= 3)
		src.verbs += typesof(/mob/System/L3_GM/verb)
	if(GM_Level >= 4)
		src.verbs += typesof(/mob/System/L4_GM/verb)
	if(GM_Level == 5)
		src.verbs += typesof(/mob/System/L5_GM/verb)

mob/proc/Remove_GM()
	src.verbs -= typesof(/mob/System/L1_GM/verb)
	src.verbs -= typesof(/mob/System/L2_GM/verb)
	src.verbs -= typesof(/mob/System/L3_GM/verb)
	src.verbs -= typesof(/mob/System/L4_GM/verb)
	src.verbs -= typesof(/mob/System/L5_GM/verb)

//-- GM Verb Proc --

proc/GMMessage(MSG)
	for(var/client/C)
		if(C.mob && C.mob.GM_Level >= 1)
			C << "\red (GM MESSAGE): \blue [MSG]"

proc/GMChat(MSG)
	for(var/client/C)
		if(C.mob && C.mob.GM_Level >= 1)
			C << "\red (GM CHAT) [usr]: \blue [MSG]"