#define DEBUG

mob/System

	// -- LEVEL 1 GM VERBS --
	L1_GM/verb
		Saga_Difficulty()
			set category = "GM"
			if(saga_difficulty == "Easy")
				switch(alert({"What Difficulty do you wish to set the Sagas to?
Medium (x2)
Hard (x3.5)
Extreme (x5)"},"Saga Difficulty","Medium","Hard","Extreme"))
					if("Medium")
						saga_difficulty = "Medium"
						world << "\red Saga Difficulty has been set to: [saga_difficulty]"
						return
					if("Hard")
						saga_difficulty = "Hard"
						world << "\red Saga Difficulty has been set to: [saga_difficulty]"
						return
					if("Extreme")
						saga_difficulty = "Extreme"
						world << "\red Saga Difficulty has been set to: [saga_difficulty]"
						return

			if(saga_difficulty == "Medium")
				switch(alert({"What Difficulty do you wish to set the Sagas to?
Easy (Default)
Hard (x3.5)
Extreme (x5)"},"Saga Difficulty","Easy","Hard","Extreme"))
					if("Easy")
						saga_difficulty = "Easy"
						world << "\red Saga Difficulty has been set to: [saga_difficulty]"
						return
					if("Hard")
						saga_difficulty = "Hard"
						world << "\red Saga Difficulty has been set to: [saga_difficulty]"
						return
					if("Extreme")
						saga_difficulty = "Extreme"
						world << "\red Saga Difficulty has been set to: [saga_difficulty]"
						return

			if(saga_difficulty == "Hard")
				switch(alert({"What Difficulty do you wish to set the Sagas to?
Easy (Default)
Medium (x2)
Extreme (x5)"},"Saga Difficulty","Easy","Hard","Extreme"))
					if("Easy")
						saga_difficulty = "Easy"
						world << "\red Saga Difficulty has been set to: [saga_difficulty]"
						return
					if("Medium")
						saga_difficulty = "Medium"
						world << "\red Saga Difficulty has been set to: [saga_difficulty]"
						return
					if("Extreme")
						saga_difficulty = "Extreme"
						world << "\red Saga Difficulty has been set to: [saga_difficulty]"
						return

			if(saga_difficulty == "Extreme")
				switch(alert({"What Difficulty do you wish to set the Sagas to?
Easy (Default)
Medium (x2)
Hard (x3.5)"},"Saga Difficulty","Easy","Medium","Hard"))
					if("Easy")
						saga_difficulty = "Easy"
						world << "\red Saga Difficulty has been set to: [saga_difficulty]"
						return
					if("Medium")
						saga_difficulty = "Medium"
						world << "\red Saga Difficulty has been set to: [saga_difficulty]"
						return
					if("Hard")
						saga_difficulty = "Hard"
						world << "\red Saga Difficulty has been set to: [saga_difficulty]"
						return


		View_Player_Stats(mob/M in world)
			set category = "GM"
			var/form = ""
			if(!M.form_1)
				form = "Normal State"

			if(M.form_1)
				if(M.race == "Saiyan" || M.race == "Half Saiyan")
					if(M.ascended_ssj)
						form = "\yellow Ascended Super Saiyan"
					else
						form = "\yellow Super Saiyan"

				if(M.race == "Changling")
					form = "\white Form 2"

				if(M.race == "Majin")
					form = "<font color=#E358B4>Punk Form</font>"

				if(M.race == "Human")
					form = "<font color = #EB7F00>Advanced Focus</font>"

				if(M.race == "Namek")
					form = "\green Super Namek"

				if(M.race == "Tuffle")
					form = "\yellow Infected Tuffle"

				if(M.race == "Bio-Android")
					form = "\green Imperfect Form"
			else
				if(M.form_2)
					if(M.race == "Saiyan" || M.race == "Half Saiyan")
						form = "\yellow Ultra Super Saiyan"
					if(M.race == "Changling")
						form = "\white Form 3"
					if(M.race == "Majin")
						form = "<font color=#E358B4>Super Form</font>"
					if(M.race == "Tuffle")
						form = "\yellow Super Tuffle"
					if(M.race == "Human")
						form = "<font color = #EB7F00>High Tension</font>"
					if(M.race == "Namek")
						form = "\green Ascended Namek"
					if(M.race == "Bio-Android")
						form = "\green Perfect Form"
				else
					if(M.form_3)
						if(M.race == "Saiyan" || M.race == "Half Saiyan")
							form = "\yellow Super Saiyan 2"
						if(M.race == "Changling")
							form = "\white Form 4"
						if(M.race == "Majin")
							form = "<font color=#E358B4>Kid Form</font>"
						if(M.race == "Tuffle")
							form = "\yellow Super Tuffle 2"
						if(M.race == "Human")
							form = "<font color = #EB7F00>Advanced High Tension</font>"
						if(M.race == "Namek")
							form = "\green Super Namek 2"
						if(M.race == "Bio-Android")
							form = "\green Perfect Power Weighted Form"
					else
						if(M.form_4)
							if(M.race == "Saiyan")
								form = "\yellow Super Saiyan 3"
							if(M.race == "Changling")
								form = "\white Form 4: 100% Power"
						else
							if(M.form_5)
								if(M.race == "Saiyan")
									form = "\yellow Super Saiyan 4"
				src << "---------------------"
				src << "<font size = 4>[M]</size>"
				src << "<font size = 2>Key: [M.key]</size>"
				src << "Powerlevel: [num2text(M.powerlevel,10000000)] / [num2text(M.powerlevel_max,10000000)]"
				src << "Ki: [num2text(M.ki,10000000)] / [num2text(M.ki_max,10000000)]"
				src << "Strength: [num2text(M.strength,10000000)] / [num2text(M.strength_max,10000000)]"
				src << "Defence: [num2text(M.defence,10000000)] / [num2text(M.defence_max,10000000)]"
				src << ""
				src << "Block Skill: [M.block] %"
				src << "Counter Skill: [M.counter] %"
				src << "Reflect Skill: [M.reflect] %"
				src << "Dodge Skill: [M.dodge] %"
				src << "Critical Skill: [M.critical] %"
				src << ""
				src << "Currently In: [form]"
				src << "Energy Code: [num2text(M.energy_code,1000000)]"
				src << "---------------------"
				src.afk_time = 0

		Admin_Chat(T as text)
			set category = "GM"
			GMChat(T)

		Mute_Player(mob/PC/M in world)
			set category = "GM"
			var/Reason
			switch(alert("Include a Reason for Muting [M]?","Mute","Yes","No"))
				if("Yes")
					var/Reason2 = input("What is the reason for Muting [M]")as text
					Reason = Reason2
			switch(alert("Set a time for Mute?","Mute","Yes","No"))
				if("Yes")
					switch(alert("Time in Minutes or Seconds?","Mute","Minutes","Seconds"))
						if("Minutes")
							var/Timer = input("How many Minutes?")as num
							if(!Reason)
								world << "\red [M] has been Muted [Timer] Minutes"
							else
								world << "\red [M] has been Muted Reason: [Reason] | [Timer] Minutes"
							Timer = (Timer * 10) * 60
							if(!M)return
							M.GM_Muted = 1
							M.mute_time = Timer
							M.MUTE_TIMER()
							world << "\red [M] has been red Unmuted"
						else
							var/Timer = input("How many Seconds?")as num
							if(!Reason)
								world << "\red [M] has been Muted [Timer] Seconds"
							else
								world << "\red [M] has been Muted Reason: [Reason] | [Timer] Seconds"
							Timer = Timer * 10
							if(!M)return
							M.GM_Muted = 1
							M.mute_time = Timer
							M.MUTE_TIMER()
							world << "\red [M] has been Unmuted"
				else
					M.GM_Muted = 1
					if(!Reason)
						world << "\red [M] has been Muted"
					else
						world << "\red [M] has been Muted Reason: [Reason]"

		Unmute_Player(mob/PC/M in world)
			set category = "GM"
			M.GM_Muted = 0
			world << "[M] has been \red Unmuted"

		Teleport(mob/M in world)
			set category = "GM"
			switch(alert("Do you want to Teleport to [M]?","","Yes","No"))
				if("Yes")
					src.loc = locate(M.x,M.y-1,M.z)
					M << "[src] has Teleported to you"
				else
					return

		Multi_Key_Check()
			set category = "GM"
			set desc = "Check all Player for Multi Keying"

			var/Found[0]
			for(var/mob/M in world)
				if(Found.Find(M))continue
				if(M.client)
					for(var/mob/M2 in world)
						if(!M2.client)continue
						if(!M2)continue
						if(M == M2)continue
						if(M.client.address == M2.client.address)
							Found += M
							Found += M2
							usr << "<B>\red Match Found!"
							usr << "<B><font color = #999999>Name:</font> [M.name] <B><font color = #999999>- Key:</font> [M.key] <B><font color = #999999>- Address:</font> [M.client.address]."
							usr << "<B><font color = #999999>Name:</font> [M2.name] <B><font color = #999999>- Key:</font> [M2.key] <B><font color = #999999>- Address:</font> [M2.client.address]."


	// -- LEVEL 2 GM VERBS --
	L2_GM/verb
		Announce(msg as message)
			set category = "GM"
			world << "<p align=center>[src] would like to Announce:<br></p><hr align=center><div align=center>[msg]<br></div><hr align=center>"

		Summon(mob/M in world)
			set category = "GM"
			switch(alert("Do you want to Summon [M]?","","Yes","No"))
				if("Yes")
					if(M.attack_lock || M.ki_lock || M.it_lock || M.buku_lock || M.it_blocked)
						M.attack_lock = 0
						M.ki_lock = 0
						M.it_lock = 0
						M.buku_lock = 0
						M.it_blocked = 0
					M.loc = locate(src.x,src.y-1,src.z)
					M << "\red [src] has Summoned you"
				else
					return

		Send_To(mob/PC/M in world)
			set category = "GM"
			switch(alert("Do you want to Send [M] to Something?","","Yes","No"))
				if("Yes")
					var/mob/new_location
					new_location = input("Teleport [M] to who?") as mob in world
					M.loc = locate(new_location.x,new_location.y-1,new_location.z)
					M << "\red [src] has Sent you to [new_location]"
				else
					return

	// -- LEVEL 3 GM VERBS --
	L3_GM/verb
		Boot_Player(mob/PC/M in world)
			set category = "GM"
			world << "[M] has been Booted"
			del(M)

		Reboot_Server()
			set category = "GM"
			switch(alert("Are you sure you want to reboot the world?","Reboot World","Yes","No"))
				if("Yes")
					goto Yes
				if("No")
					return
			Yes
			var/Time = input("How Long Till Reboot?")in list("Reboot Now","Set Time Reboot")
			if(Time == "Reboot Now")
				world.Reboot()
			if(Time == "Set Time Reboot")
				TryAgain
				var/TType = alert("Select Time: Seconds or Minutes.","Select Time","Seconds","Minutes")
				var/TTime = input("Select Amount Of Time. (In [TType])")as num
				if(TTime <= 0)
					usr << "Please Enter A Valid Number"
					goto TryAgain
				if(TType == "Seconds")
					TTime *= 10
				if(TType == "Minutes")
					TTime = (TTime * 10) * 60
				while(TTime > 6000)
					world<<"\red World Rebooting In [TTime/10] Seconds, or [TTime/600] Minutes."
					TTime -= 6000
					sleep(6000)
				while(TTime > 600)
					world<<"\red World Rebooting In [TTime/10] Seconds, or [TTime/600] Minutes."
					TTime -= 600
					sleep(600)
				while(TTime > 100)
					world<<"\red World Rebooting In [TTime/10] Seconds."
					TTime -= 100
					sleep(100)
				while(TTime >= 10)
					world<<"\red World Rebooting In [TTime/10] Seconds."
					TTime -= 10
					sleep(10)
				world << "\red World Rebooting Now!"
				for(var/client/C)
					if(C.mob)
						C.mob.client.Save()
				sleep(15)
				world.Reboot()

	// -- LEVEL 4 GM VERBS --
	L4_GM/verb

		/******************/
		/****World Mute****/
		/******************/

		World_Mute()
			set category = "GM"
			World_Mute = 1
			world << "\red [src] has Muted the World"

		World_Unmute()
			set category = "GM"
			World_Mute = 0
			world << "\red [src] has Unmuted the World"

		/******************/
		/****Ban Player****/
		/******************/

		Ban_Player(mob/PC/M in world)
			set category = "GM"
			var/savefile/H = new("H_Admin.ban")
			var/Reason
			switch(alert("Include a Reason for Banning [M]?","Mute","Yes","No"))
				if("Yes")
					var/Reason2 = input("What is the reason for Muting [M]")as text
					Reason = Reason2
			switch(alert("Ban [M]'s Key, IP or Both?","Ban [M]","Key","IP","Both"))
				if("Key")
					Banned_Key += M.ckey
					H["Banned_Key"] << Banned_Key
				if("IP")
					Banned_IP += M.client.address
					H["Banned_IP"] << Banned_IP
				if("Both")
					Banned_Key += M.ckey
					Banned_IP += M.client.address
					H["Banned_Key"] << Banned_Key
					H["Banned_IP"] << Banned_IP
			if(!Reason)
				world << "\red [M] has been Banned"
			else
				world << "\red [M] has been Banned Reason: [Reason]"
			del(M)

		Unban_Player()
			set category = "GM"
			var/savefile/H = new("H_Admin.ban")
			switch(alert("Unban a Key or IP?","Unban","Key","IP"))
				if("Key")
					var/M = input("What Key do you want to Unban?","Unban Key")as null | anything in Banned_Key
					if(!M)src << "No Keys to Unban!";return
					Banned_Key -= M
					H["Banned_Key"] << Banned_Key
					src << "\red [M] has been Unbanned"
					GMMessage("[src] Unbanned Key: [M]")

				if("IP")
					var/M = input("What IP do you want to Unban?","Unban IP")as null | anything in Banned_IP
					if(!M)src << "No IPs to Unban!";return
					Banned_IP -= M
					H["Banned_IP"] << Banned_IP
					src << "\red [M] has been Unbanned"
					GMMessage("[src] Unbanned IP: [M]")

		View_Banned_Players()
			set category = "GM"
			switch(alert("View Banned Keys or IPs?","View Banned People","Keys","IPs"))
				if("Keys")
					input("Banned Keys:","Banned List")as null | anything in Banned_Key
					return
				else
					input("Banned IPs:","Banned List")as null | anything in Banned_IP
					return
		/****************************/
		/****Promote/Demote Admin****/
		/****************************/

		Promote_Admin(mob/PC/M in world)
			set category = "GM"
			var/GM_Rank
			var/new_GM_Level = input("What Level of Admin do you wish to give them? (1-4)")as num | null

			if(!new_GM_Level)
				return

			if(new_GM_Level < 0 || new_GM_Level > 4)
				return

			if(new_GM_Level <= M.GM_Level)
				src << "Cannot Promote them to a Lower Level!"
				return

			if(M.GM_Level >= src.GM_Level)
				src << "You can only Promote Admin's lower rank than you!"
				return

			switch(new_GM_Level)
				if(1) GM_Rank = "Low Enforcer"
				if(2) GM_Rank = "Medium Enforcer"
				if(3) GM_Rank = "High Enforcer"
				if(4) GM_Rank = "Master Enforcer"

			switch(alert({"Is This Correct?
Target: [M]
Selected Rank: [new_GM_Level], [GM_Rank]"},"Promoting Admin","Yes","No"))
				if("Yes")
					switch(M.GM_Level)
						if(1) H_L1_GM -= M.key
						if(2) H_L2_GM -= M.key
						if(3) H_L3_GM -= M.key
						if(4) H_L4_GM -= M.key
					switch(new_GM_Level)
						if(1) H_L1_GM += M.key
						if(2) H_L2_GM += M.key
						if(3) H_L3_GM += M.key
						if(4) H_L4_GM += M.key

					M.GM_Level = new_GM_Level
					spawn(5) M.Apply_GM(new_GM_Level)
					GMMessage("[src] has Promoted [M] to Rank: [GM_Rank]")

				if("No")
					return

		Demote_Admin(mob/PC/M in world)
			set category = "GM"
			var/GM_Rank
			var/new_GM_Level = input("What Level of Admin do you wish to give them? (0-4)")as num | null

			if(!new_GM_Level)
				return

			if(new_GM_Level < 0 || new_GM_Level > 4)
				return

			if(new_GM_Level >= M.GM_Level)
				src << "Cannot Domote them to a higher level!"
				return
			if(new_GM_Level >= src.GM_Level)
				src << "You are not a high enough rank!"
				return

			if(M.GM_Level >= src.GM_Level)
				src << "You can only Demote Admin's lower rank than you!"
				return

			switch(new_GM_Level)
				if(1) GM_Rank = "Low Enforcer"
				if(2) GM_Rank = "Medium Enforcer"
				if(3) GM_Rank = "High Enforcer"
				if(4) GM_Rank = "Master Enforcer"

			switch(alert({"Is This Correct?
Target: [M]
Selected Rank: [new_GM_Level], [GM_Rank]"},"Promoting Admin","Yes","No"))
				if("Yes")
					switch(M.GM_Level)
						if(1) H_L1_GM -= M.key
						if(2) H_L2_GM -= M.key
						if(3) H_L3_GM -= M.key
						if(4) H_L4_GM -= M.key
					switch(new_GM_Level)
						if(1) H_L1_GM += M.key
						if(2) H_L2_GM += M.key
						if(3) H_L3_GM += M.key
						if(4) H_L4_GM += M.key

					M.GM_Level = new_GM_Level
					spawn(5) M.Remove_GM()
					spawn(5) M.Apply_GM(new_GM_Level)
					GMMessage("[src] has Promoted [M] to Rank: [GM_Rank]")

				if("No")
					return

		Edit(mob/O as obj|mob in world)
			set category = "GM"
			if(ismob(O))
				if(O.GM_Level > src.GM_Level)
					src << "You can only Edit Admin's lower rank than you!"
					return
			var/Choices[0]
			for(var/V in O.vars) Choices+=V
			Choices-="key"
			Choices-="ckey"
			Choices-="contents"
			Choices-="verbs"
			Choices-="overlays"
			Choices-="underlays"
			Choices-="GM_Level"
			Choices-="GM_Muted"
			Choices-="vars"
			Choices-="group"
			Choices-="type"
			Choices-="parent_type"
			Choices-="client"
			var/variable = input("Which var?","Var") in Choices
			var/default
			var/typeof = O.vars[variable]
			var/dir

			if(isnull(typeof))
				usr << "Unable to determine variable type."

			else if(isnum(typeof))
				usr << "Variable appears to be <b>NUM</b>."
				default = "num"
				dir = 1

			else if(istext(typeof))
				usr << "Variable appears to be <b>TEXT</b>."
				default = "text"

			else if(isloc(typeof))
				usr << "Variable appears to be <b>REFERENCE</b>."
				default = "reference"

			else if(isicon(typeof))
				usr << "Variable appears to be <b>ICON</b>."
				typeof = "\icon[typeof]"
				default = "icon"

			else if(istype(typeof,/atom) || istype(typeof,/datum))
				usr << "Variable appears to be <b>TYPE</b>."
				default = "type"

			else if(istype(typeof,/list))
				usr << "Variable appears to be <b>LIST</b>."
				default = "cancel"

			else if(istype(typeof,/client))
				usr << "Variable appears to be <b>CLIENT</b>."
				default = "cancel"

			else
				usr << "Variable appears to be <b>FILE</b>."
				default = "file"

			usr << "Variable contains: [typeof]"
			if(dir)
				switch(typeof)
					if(1)
						dir = "NORTH"
					if(2)
						dir = "SOUTH"
					if(4)
						dir = "EAST"
					if(8)
						dir = "WEST"
					if(5)
						dir = "NORTHEAST"
					if(6)
						dir = "SOUTHEAST"
					if(9)
						dir = "NORTHWEST"
					if(10)
						dir = "SOUTHWEST"
					else
						dir = null
				if(dir)
					usr << "If a direction, direction is: [dir]"

			var/class = input("What kind of variable?","Variable Type",default) in list("text",
				"num","type","reference","icon","file","restore to default","cancel")

			switch(class)
				if("cancel")
					return

				if("restore to default")
					O.vars[variable] = initial(O.vars[variable])

				if("text")
					O.vars[variable] = input("Enter new text:","Text",\
						O.vars[variable]) as text

				if("num")
					O.vars[variable] = input("Enter new number:","Num",\
						O.vars[variable]) as num

				if("type")
					O.vars[variable] = input("Enter type:","Type",O.vars[variable]) \
						in typesof(/obj,/mob,/area,/turf)

				if("reference")
					O.vars[variable] = input("Select reference:","Reference",\
						O.vars[variable]) as mob|obj|turf|area in world

				if("file")
					O.vars[variable] = input("Pick file:","File",O.vars[variable]) \
						as file

				if("icon")
					O.vars[variable] = input("Pick icon:","Icon",O.vars[variable]) \
						as icon

	// -- LEVEL 5 GM VERBS --
	L5_GM/verb

		/***********************/
		/****Server Shutdown****/
		/***********************/

		Shutdown_Server()
			set category = "GM"
			var/Shutdown = 0
			switch(alert("Are You Sure You Want To Shutdown The Shutdown?","Server Shutdown","Yes","No","Disable Server Shutdown"))
				if("Yes")
					if(!Shutdown)
						world << "Server Shutdown In 30 Seconds."
						spawn(5) Shutdown = 1
						sleep(100)
						var/Time = 200
						while(Shutdown && Time > 0)
							src << "\red Server Shutdown In [Time/10] Seconds"
							Time -= 100
							if(Time <= 0)
								world << "\red Shutting Down Server."
								for(var/client/C)
									if(C.mob)
										C.mob.client.Save()
								sleep(15)
								del(world)
							sleep(100)
					else
						src << "Server is already Shutting down!"
						return

				if("Disable Server Shutdown")
					if(!Shutdown)
						src << "The Server isn't trying to Shutdown."
						return
					else
						Shutdown = 0
						src << "Server Shutdown Aborted"
						return
				else
					return