mob/PC/Stat()

	//-------VITALS------------------------------

	if(src.tab_vitals)
		statpanel("Vitals")
		stat("Karma:","[src.karma]: [src.karma_rating]%")
		if(src.race == "Saiyan")
			if(src.rage_chromosome)
				stat("Gene Type:","Honour")
			if(src.train_chromosome)
				stat("Gene Type:","Pride")
		stat("--------","")
		stat("Level:",level)
		stat("EXP:","[round(src.exp / src.tnl * 100)] %")
		if(src.tp > 0)
			stat("Training Points:",src.tp)
		stat("--------","")
		stat("Powerlevel:","[num2text(round(src.powerlevel),1000000)] / [num2text(round(src.powerlevel_max),1000000)]")
		stat("Ki:","[num2text(round(src.ki),1000000)] / [num2text(round(src.ki_max),1000000)]")
		stat("Strength:","[num2text(round(src.strength),1000000)]")
		stat("Defence:","[num2text(round(src.defence),1000000)]")
		stat("--------","")
		stat("Rage:","[src.rage] %")
		stat("Fatigue:","[round(src.fatigue / src.fatigue_max * 100)] %")
		stat("Energy Code:","[num2text(src.energy_code,100000)]")

	//-------SKILLS------------------------------

	if(src.tab_skills)
		statpanel("Skills")
		stat("Unarmed:","[round((src.unarmed / src.unarmed_max) * 100)] %")
		stat("--------","")
		if(src.race == "Saiyan" || src.race == "Half Saiyan")
			stat("Transformation EXP:","[round(src.ssj_exp / src.ssj_tnl * 100)] %")
		if(src.race == "Human" || src.race == "Changling")
			stat("Transformation EXP:","[round(src.form_1_exp / src.form_1_tnl * 100)] %")
		if(src.race != "Namek" || src.race != "Majin" || src.race != "Android")
			stat("Transformation Drain:","[src.upkeep] %")
		stat("--------","")
		stat("Chance to Block:","[src.block] %")
		stat("Chance to Counter:","[src.counter] %")
		stat("Chance to Dodge:","[src.dodge] %")
		stat("Chance to Reflect:","[src.reflect] %")
		stat("Chance to Critical:","[src.critical] %")
		stat("--------","")
		stat("Combat Points:",src.combat_points)
		if(!src.in_guild)
			stat("Combat Rank:","None")
		else
			stat("Combat Rank:",src.guild_rank)

	//-------QUESTS------------------------------

	if(src.tab_quests)
		for(var/obj/Quests/O in contents)
			statpanel("Quests")
			stat("")
			stat(O)

	//-------INVENTORY------------------------------

	if(src.tab_inventory)
		statpanel("Inventory")
		stat("Head:",src.head)
		stat("Back:",src.back)
		stat("Chest:",src.chest)
		stat("Underclothing:",src.underclothes)
		stat("Arms:",src.arms)
		stat("Hands:",src.hands)
//		stat("Waist:","EMPTY")
		stat("Legs:",src.legs)
		stat("Feet:",src.feet)
		if(src.inven_min > 0)
			stat("--------","")
		for(var/obj/Equipment/O in contents)
			stat(O)
		for(var/obj/Dragonballs/O2 in contents)
			stat(O2)
		for(var/obj/Guild/G in contents)
			stat(G)
		stat("--------","")
		stat("Zenni:","[src.zenni]")
		stat("Banked Zenni:","[src.banked_zenni]")
		var/count = 0
		for(var/obj/Equipment/E in contents)
			count ++
		for(var/obj/Gym/G in contents)
			count ++
		src.inven_min = count
		stat("Space:","[src.inven_min] / [src.inven_max]")

	//-------GUILD----------------------------------

	if(src.in_guild)
		statpanel("Guild Members")
		for(var/mob/PC/M in world)
			if(M.guild_name == src.guild_name)
				stat(M)
				stat("Energy Code:","[num2text(M.energy_code,1000000)]")
				stat("","")