mob/var/safe = 0

mob/PC
	verb
		Attack(mob/M in get_step(usr,usr.dir))
			set category = "Combat"
			if(!M)return
			var/attack_power = round(usr.strength + ((usr.unarmed / usr.unarmed_max) * usr.strength) + usr.powerlevel_max / 100)
			var/defence_power = M.defence
			var/damage = attack_power - defence_power
			var/combat_exp_bonus = (usr.level / 10)

			if(combat_exp_bonus <= 0)
				combat_exp_bonus = 0

			if(damage <= 0)
				damage = 0

			var/attack_text = rand(1,3)
			var/text = ""

			if(attack_text)
				text = "\red [usr] Punches you in the Face"
			if(attack_text == 2)
				text = "\red [usr] Kicks you in the Chest"
			if(attack_text == 3)
				text = "\red [usr] Punches you in the Stomach"

			if(!M)
				return

			if(usr.doing || usr.KO)
				return

			if(M.safe)
				usr << "A froce stops you from attacking [M]"
				return

			if(M.KO)
				usr << "They are already Knocked Out. Finish them!"
				return

			if(usr.cooldown)
				return

			if(usr.attack_lock)
				return

			if(M.type == /mob/PC)

				for(var/turf/Floors/Safe_Zone/S in view(6))
					if(S in view(8))
						usr << "They are in a Safe Zone!"
						return

				if(usr.safe)
					usr << "You are currently Safe and cannot Attack!"
					return

				if(!M.pk)
					usr << "They are not a Combatant!"
					return

				if(!usr.pk)
					usr << "You are not a Combatant!"
					return

				if(M.dead && M.race != "Majin")
					usr << "You cannot attack [M] because they are Dead!"
					return

				if(prob(M.dodge))
					flick("attack",usr)
					flick("IT",M)
					M << "\green You manage to Dodge [usr]'s attack"
					usr << "\green [M] manages to Dodge your attack"
					usr.cooldown = 1
					spawn(usr.speed * 2) usr.cooldown = 0
					return
				else
					if(prob(M.block))
						flick("attack",usr)
						M << "\green You manage to Block some of [usr]'s attack"
						usr << "\green [M] manages to Block some of your attack"
						M.powerlevel -= damage / 4
						M.KO()
						usr.exp += combat_exp_bonus
						spawn() usr.Level_Up()
						usr.cooldown = 1
						spawn(usr.speed * 2) usr.cooldown = 0
						return
					else
						if(prob(M.counter))
							flick("attack",M)
							M << "\green You manage to Counter [usr]'s attack"
							usr << "\green [M] manages to Counter your attack and attacks back"
							usr.powerlevel -= ((damage) + (damage *0.30))
							spawn() usr.KO()
							M.exp += combat_exp_bonus
							M.unarmed_exp += rand(5,20)
							spawn() M.UA_Level_Up()
							spawn() M.Level_Up()
							usr.cooldown = 1
							spawn(usr.speed * 2) usr.cooldown = 0
							return
						else
							if(prob(usr.critical))
								flick("attack",usr)
								M << "[text], which sends you flying back"
								usr << "\red You hit [M] with a Critical Hit, sending them flying back"
								var/FallDir = get_dir(usr,M)
								usr.dir = FallDir
								step(M,FallDir)
								switch(FallDir)
									if(NORTH)M.dir = SOUTH
									if(NORTHWEST)M.dir = SOUTHEAST
									if(WEST)M.dir = EAST
									if(SOUTHWEST)M.dir = NORTHEAST
									if(SOUTH)M.dir = NORTH
									if(SOUTHEAST)M.dir = NORTHWEST
									if(EAST)M.dir = WEST
									if(NORTHEAST)M.dir = SOUTHWEST
								M.frozen = 1
								M.doing = 1
								spawn(10)
									M.frozen = 0
									M.doing = 0
								M.powerlevel -= (damage * 2)
								spawn() M.KO()
								usr.exp += combat_exp_bonus
								usr.unarmed_exp += rand(5,20)
								spawn() usr.UA_Level_Up()
								spawn() usr.Level_Up()
								usr.cooldown = 1
								spawn(usr.speed * 2) usr.cooldown = 0
								return
							else
								flick("attack",usr)
								M << "[text]"
								usr << "\red You hit [M]"
								M.powerlevel -= damage
								spawn() M.KO()
								usr.exp += combat_exp_bonus
								usr.unarmed_exp += rand(5,20)
								spawn() usr.UA_Level_Up()
								spawn() usr.Level_Up()
								usr.cooldown = 1
								spawn(usr.speed * 2) usr.cooldown = 0
								return
			else
				if(prob(M.dodge))
					flick("attack",usr)
					flick("IT",M)
					M.attacker = usr.name
					usr << "\green [M] manages to Dodge your attack"
					usr.exp += combat_exp_bonus
					spawn() usr.Level_Up()
					usr.cooldown = 1
					spawn(usr.speed * 2) usr.cooldown = 0
					return
				else
					if(prob(M.block))
						flick("attack",usr)
						usr << "\green [M] manage to Block some of your attack"
						M.attacker = usr.name
						M.powerlevel -= damage / 4
						spawn() M.KO()
						usr.exp += combat_exp_bonus
						spawn() usr.Level_Up()
						usr.cooldown = 1
						spawn(usr.speed * 2) usr.cooldown = 0
						return
					else
						if(prob(M.counter))
							flick("attack",M)
							usr << "\green [M] manages to Counter your attack and attacks back"
							usr.powerlevel -= ((damage) + (damage *0.30))
							spawn() usr.KO()
							usr.cooldown = 1
							spawn(usr.speed * 2) usr.cooldown = 0
							return
						else
							if(prob(usr.critical))
								flick("attack",usr)
								M << "[text]"
								usr << "\red You hit [M] with a Critical Hit"
								M.attacker = usr.name
								M.powerlevel -= (damage * 2)
								spawn() M.KO()
								usr.exp += combat_exp_bonus
								usr.unarmed_exp += rand(5,20)
								spawn() usr.UA_Level_Up()
								spawn() usr.Level_Up()
								usr.cooldown = 1
								spawn(usr.speed * 2) usr.cooldown = 0
								return
							else
								flick("attack",usr)
								M << "[text]"
								usr << "\red You hit [M]"
								M.attacker = usr.name
								M.powerlevel -= damage
								spawn() M.KO()
								usr.exp += combat_exp_bonus
								usr.unarmed_exp += rand(5,20)
								spawn() usr.UA_Level_Up()
								spawn() usr.Level_Up()
								usr.cooldown = 1
								spawn(usr.speed * 2) usr.cooldown = 0
								return
			usr.afk_time = 0