mob/var/combat_points = 0
mob/var/combat_points_max = 0
mob/var/witness_deaths = 0

mob
	proc
		Rage_Unleash()
			set background = 1

			if(src.race == "Saiyan" && src.rage_chromosome && !src.gone_ssj)
				if(src.powerlevel_max >= 100000)
					if(src.witness_deaths >= 1 && src.rage >= 50)
						if(!src.gone_ssj)
							src.gone_ssj = 1
							for(var/mob/PC/M in view(6))
								if(M != src)
									M << "\white <I>[src.name] Stands there, their face twisted with Rage..."
									spawn(10) M << "\white <I>[src.name] clentchs their fists, as tears well in their eyes. Veins protrude from [src.name]'s hands and forehead as the ground rumbles"

							src << "\white <I>You feel an uncontrollable rage burning in you as you remember the people who have died infront of you"
							sleep(10)
							src << "\white <I>You clentch your fists, as tears well in your eyes. Veins protrude from your hands and forehead as the ground rumbles"
							src.icon_state = "enrage"
							sleep(10)
							view(6) << "\white [src.name]: I WILL NOT LET IT HAPPEN ANYMORE!"
							src.powerlevel = src.powerlevel_max
							src.contents += new/obj/Transform/Transform
							src.contents += new/obj/Transform/Revert
							spawn() src.Saiyan_Trans()
							Explode(new /Effect/BasicBoom(src.loc,1,3))

			if(src.race == "Saiyan" || src.race == "Half Saiyan" && !src.gone_ssj2)
				if(src.powerlevel_max >= 3500000)
					if(src.witness_deaths >= 5 && src.rage >= 100)
						if(!src.gone_ssj)
							src.gone_ssj = 1
							for(var/mob/PC/M in view(6))
								if(M != src)
									M << "\white <I>[src.name] Stands there, their face twisted with Rage..."
									spawn(10) M << "\white <I>[src.name] clentchs their fists, as tears well in their eyes. Veins protrude from [src.name]'s hands and forehead as the ground rumbles"

							src << "\white <I>You feel an uncontrollable rage burning in you as you remember the people who have died infront of you"
							sleep(10)
							src << "\white <I>You clentch your fists, as tears well in your eyes. Veins protrude from your hands and forehead as the ground rumbles"
							src.icon_state = "enrage"
							sleep(10)
							view(6) << "\white [src.name]: I must let it all go...I musn't hold back...I may not be strong enough...but..."
							sleep(10)
							view(6) << "\white [src.name]: I can't...give...UP! I WON'T GIVE UP!!"
							src.powerlevel = src.powerlevel_max
							src.form_1 = 1
							src.form_2 = 1
							src.gone_ssj2 = 1
							if(src.race == "Saiyan")
								spawn() src.Saiyan_Trans()
							if(src.race == "Half Saiyan")
								spawn() src.Half_Saiyan_Trans()
							Explode(new /Effect/BasicBoom(src.loc,1,4))

 /***************\
|*****************|
|***MELEE DEATH***|
|*****************|
 \***************/

mob/proc/DeathCheck()
	if(src.powerlevel <= 0)
		..()

mob/Monster/DeathCheck(mob/PC/M)
	if(src.powerlevel <= 0)
		var/bonus_exp = src.tnl
		if("minor_exp_buff" in M.buffs)
			bonus_exp += bonus_exp * 0.05
		if("exp_buff" in M.buffs)
			bonus_exp += bonus_exp * 0.25
		M.exp += bonus_exp
		M.zenni += src.zenni
		src.killer = M.name
		M << "\white Zenni +[src.zenni]"
		M << "\white EXP +[bonus_exp]"
		spawn() M.Level_Up()

		if(src.race == "Green Saibaman")
			M.green_kills ++

		if(src.race == "Henchman")
			M.thug_kills ++

		if(src.race == "Namekian Warrior")
			M.namek_kills ++

		del(src)
		..()

mob/Saga/DeathCheck(mob/PC/M)
	if(src.powerlevel <= 0)
		var/bonus_exp = src.tnl
		if("minor_exp_buff" in M.buffs)
			bonus_exp += bonus_exp * 0.05
		if("exp_buff" in M.buffs)
			bonus_exp += bonus_exp * 0.25
		M.exp += bonus_exp
		M.zenni += src.zenni
		M << "\white Zenni +[src.zenni]"
		M << "\white EXP +[bonus_exp]"
		spawn() M.Level_Up()

		if(raditz_saga_on)
			raditz_saga ++

		if(vegeta_saga_on)
			vegeta_saga ++

		if(ginyu_saga_on)
			ginyu_saga ++

		if(frieza_saga_on)
			frieza_saga ++

		if(android_saga_on)
			android_saga ++

		if(cell_saga_on)
			cell_saga ++

		if(majin_saga_on)
			majin_saga ++

/*		if(goku_piccolo_saga_on)
			goku_piccolo_saga ++

		if(z_force_saga_on)
			z_force_saga ++

		if(z_force_2_saga_on)
			z_force_2_saga ++

		if(z_force2_2_saga_on)
			z_force2_2_saga ++

		if(super_piccolo_saga_on)
			super_piccolo_saga ++

		if(super_goku_saga_on)
			super_goku_saga ++

		if(ssj_goku_saga2_on)
			ssj_goku_saga2 ++

		if(trunks_saga_on)
			trunks_saga ++

		if(ssj_goku_2_saga_on)
			ssj_goku_2_saga ++

		if(ssj_vegeta_saga_on)
			ssj_vegeta_saga ++

		if(super_piccolo_2_saga_on)
			super_piccolo_2_saga ++

		if(ascended_vegeta_saga_on)
			ascended_vegeta_saga ++

		if(ascended_trunks_saga_on)
			ascended_trunks_saga ++

		if(z_fighters_3_saga_on)
			z_fighters_3_saga ++

		if(ssj_2_gohan_on)
			ssj_2_gohan ++

		if(ssj_2_gohan_2_saga_on)
			ssj_2_gohan_2_saga ++

		if(ssj_2_goku_saga_on)
			ssj_2_goku_saga ++

		if(gotenks_saga_on)
			gotenks_saga ++

		if(mystic_gohan_saga_on)
			mystic_gohan_saga ++

		if(vegito_saga_on)
			vegito_saga ++

		if(goku_vegeta_kais_saga_on)
			goku_vegeta_kais_saga ++
*/
		del(src)
		..()

mob/PC/DeathCheck(mob/M)
	if(src.powerlevel <= 0)

		if(M.type == /mob/Monster/Simulator_NPC)
			spawn(35) del(M)

		if(src.level >= M.level / 4)
			if(M.combat_points < M.combat_points_max)
				M.combat_points += 50
				M << "Your Combat Points have increased by: \red 50"

		if(M.karma == src.karma)
			M.karma_rating -= 0.5
		else
			M.karma_rating += 0.5

		if(M.karma_rating < 0)
			if(M.karma == "Good")
				M << "<I>You feel an Evil inside of you begin to awaken..."
				M.karma = "Evil"
				M.karma_rating = 0
			else
				M << "<I>You feel the Good inside of you begin to awaken..."
				M.karma = "Good"
				M.karma_rating = 0

		spawn() src.Power_Redefine()

		if(src.race == "Majin")
			if(!src.regen_dead)
				src.icon_state = "Dead"
				src.frozen = 1
				src.doing = 1
				src.density = 0
				src.ki_lock = 1
				src.it_lock = 1
				src.regen_dead = 1
				src.powerlevel = 0
				src.KO = 0
				src.rage = 0
				src.sight &= ~BLIND
			else
				src.buku = 0
				src.rest = 0
				src.frozen = 0
				src.boxing = 0
				src.focus_boxing = 0
				src.doing = 0
				src.icon_state = ""
				src.density = 1
				src.loc = locate(55,6,3)
				src.attack_lock = 0
				src.ki_lock = 0
				src.dead = 1
				src.it_lock = 0
				src.it_blocked = 0
				src.regen_dead = 0
				src.powerlevel = 50
				src.KO = 0
				src.rage = 0
				src.sight &= ~BLIND
				src.overlays += src.halo
				src.deaths += 1
				M.kills += 1
				src << "Your body was completely Destroyed!"
				world << "<FONT color = red>Battle Information:<FONT color = White> [src] died at the hands of [M]!"

		else
			src.buku = 0
			src.dead = 1
			src.rest = 0
			src.frozen = 0
			src.boxing = 0
			src.doing = 0
			src.focus_boxing = 0
			src.icon_state = ""
			src.density = 1
			src.loc = locate(55,6,3)
			src.attack_lock = 0
			src.ki_lock = 0
			src.it_lock = 0
			src.it_blocked = 0
			src.powerlevel = 50
			src.KO = 0
			src.rage = 0
			src.sight &= ~BLIND
			src.overlays += src.halo
			src.deaths += 1
			M.kills += 1
			world << "<FONT color = red>Battle Information:<FONT color = White> [src] died at the hands of [M]!"

		for(var/mob/PC/M2 in view(12))
			if(!M2)return
			if(M2.race == "Saiyan" || M2.race == "Half Saiyan")
				M2.witness_deaths ++
				spawn() M2.Rage_Unleash()
			if(M2 == M)continue
			M2 << "\red You feel your Rage Grow..."
			M2.rage += round(rand(20,50))
			if(M2.rage >= 100)
				M2.rage = 100


 /***************\
|*****************|
|*SMALL KI  DEATH*|
|*****************|
 \***************/

mob/proc/SmallKiDeathCheck()
	if(src.powerlevel <= 0)
		..()

mob/Monster/SmallKiDeathCheck(mob/PC/M)
	if(src.powerlevel <= 0)
		new/obj/techs/Overlays/Crater_Small(src.loc)

		var/bonus_exp = src.tnl
		if("minor_exp_buff" in M.buffs)
			bonus_exp += bonus_exp * 0.05
		if("exp_buff" in M.buffs)
			bonus_exp += bonus_exp * 0.25
		M.exp += bonus_exp
		M.zenni += src.zenni
		src.killer = M.name
		M << "\white Zenni +[src.zenni]"
		M << "\white EXP +[bonus_exp]"
		spawn() M.Level_Up()

		if(src.race == "Green Saibaman")
			M.green_kills ++

		if(src.race == "Henchman")
			M.thug_kills ++

		if(src.race == "Namekian Warrior")
			M.namek_kills ++

		M.kills ++
		del(src)
		..()

mob/Saga/SmallKiDeathCheck(mob/PC/M)
	if(src.powerlevel <= 0)

		var/bonus_exp = src.tnl
		if("minor_exp_buff" in M.buffs)
			bonus_exp += bonus_exp * 0.05
		if("exp_buff" in M.buffs)
			bonus_exp += bonus_exp * 0.25
		M.exp += bonus_exp
		M.zenni += src.zenni
		M << "\white Zenni +[src.zenni]"
		M << "\white EXP +[bonus_exp]"
		spawn() M.Level_Up()

		if(raditz_saga_on)
			raditz_saga ++

		if(vegeta_saga_on)
			vegeta_saga ++

		if(ginyu_saga_on)
			ginyu_saga ++

		if(frieza_saga_on)
			frieza_saga ++

		if(android_saga_on)
			android_saga ++

		if(cell_saga_on)
			cell_saga ++

		if(majin_saga_on)
			majin_saga ++

/*		if(goku_piccolo_saga_on)
			goku_piccolo_saga ++

		if(z_force_saga_on)
			z_force_saga ++

		if(z_force_saga2_on)
			z_force_saga2 ++

		if(z_force_2_saga_on)
			z_force_2_saga ++

		if(z_force2_2_saga_on)
			z_force2_2_saga ++

		if(super_piccolo_saga_on)
			super_piccolo_saga ++

		if(super_goku_saga_on)
			super_goku_saga ++

		if(ssj_goku_saga2_on)
			ssj_goku_saga2 ++

		if(trunks_saga_on)
			trunks_saga ++

		if(ssj_goku_2_saga_on)
			ssj_goku_2_saga ++

		if(ssj_vegeta_saga_on)
			ssj_vegeta_saga ++

		if(super_piccolo_2_saga_on)
			super_piccolo_2_saga ++

		if(ascended_vegeta_saga_on)
			ascended_vegeta_saga ++

		if(ascended_trunks_saga_on)
			ascended_trunks_saga ++

		if(z_fighters_3_saga_on)
			z_fighters_3_saga ++

		if(ssj_2_gohan_on)
			ssj_2_gohan ++

		if(ssj_2_gohan_2_saga_on)
			ssj_2_gohan_2_saga ++

		if(ssj_2_goku_saga_on)
			ssj_2_goku_saga ++

		if(gotenks_saga_on)
			gotenks_saga ++

		if(mystic_gohan_saga_on)
			mystic_gohan_saga ++

		if(vegito_saga_on)
			vegito_saga ++

		if(goku_vegeta_kais_saga_on)
			goku_vegeta_kais_saga ++
*/
		del(src)
		..()


mob/PC/SmallKiDeathCheck(mob/M)
	if(src.powerlevel <= 0)
		new/obj/techs/Overlays/Crater_Small(src.loc)

		if(src.level >= M.level / 4)
			if(M.combat_points < M.combat_points_max)
				M.combat_points += 50
				M << "Your Combat Points have increased by: \red 50"

		if(M.karma == src.karma)
			M.karma_rating -= 0.5
		else
			M.karma_rating += 0.5

		if(M.karma_rating < 0)
			if(M.karma == "Good")
				M << "<I>You feel an Evil inside of you begin to awaken..."
				M.karma = "Evil"
				M.karma_rating = 0
			else
				M << "<I>You feel the Good inside of you begin to awaken..."
				M.karma = "Good"
				M.karma_rating = 0

		spawn() src.Power_Redefine()

		if(src.race == "Majin")
			if(!src.regen_dead)
				src.icon_state = "Dead"
				src.frozen = 1
				src.boxing = 0
				src.focus_boxing = 0
				src.doing = 1
				src.density = 1
				src.attack_lock = 1
				src.ki_lock = 1
				src.it_lock = 1
				src.regen_dead = 1
				src.powerlevel = 0
				src.KO = 0
				src.rage = 0
				src.sight &= ~BLIND
				M.kills += 1
			else
				src.buku = 0
				src.rest = 0
				src.frozen = 0
				src.boxing = 0
				src.focus_boxing = 0
				src.doing = 0
				src.icon_state = ""
				src.density = 1
				src.loc = locate(55,6,3)
				src.attack_lock = 0
				src.ki_lock = 0
				src.dead = 1
				src.it_lock = 0
				src.it_blocked = 0
				src.regen_dead = 0
				src.powerlevel = 50
				src.KO = 0
				src.rage = 0
				src.sight &= ~BLIND
				src.overlays += src.halo
				src.deaths += 1
				M.kills += 1
				src << "Your body was completely Destroyed!"
				world << "<FONT color = red>Battle Information:<FONT color = White> [src] died at the hands of [M]!"

		else
			src.buku = 0
			src.dead = 1
			src.rest = 0
			src.frozen = 0
			src.boxing = 0
			src.focus_boxing = 0
			src.doing = 0
			src.icon_state = ""
			src.density = 1
			src.loc = locate(55,6,3)
			src.attack_lock = 0
			src.ki_lock = 0
			src.it_lock = 0
			src.it_blocked = 0
			src.powerlevel = 50
			src.KO = 0
			src.rage = 0
			src.sight &= ~BLIND
			src.overlays += src.halo
			src.deaths += 1
			M.kills += 1
			world << "<FONT color = red>Battle Information:<FONT color = White> [src] died at the hands of [M]!"

		for(var/mob/PC/M2 in view(12))
			if(!M2)return
			if(M2.race == "Saiyan" || M2.race == "Half Saiyan")
				M2.witness_deaths ++
				spawn() M2.Rage_Unleash()
			if(M2 == M)continue
			M2 << "\red You feel your Rage Grow..."
			M2.rage += round(rand(20,50))
			if(M2.rage >= 100)
				M2.rage = 100

 /***************\
|*****************|
|**BIG KI  DEATH**|
|*****************|
 \***************/

mob/proc/BigKiDeathCheck()
	if(src.powerlevel <= 0)
		..()

mob/Monster/BigKiDeathCheck(mob/PC/M)
	if(src.powerlevel <= 0)
		new/obj/techs/Overlays/Crater_Center(src.loc)

		var/bonus_exp = src.tnl
		if("minor_exp_buff" in M.buffs)
			bonus_exp += bonus_exp * 0.05
		if("exp_buff" in M.buffs)
			bonus_exp += bonus_exp * 0.25
		M.exp += bonus_exp
		M.zenni += src.zenni
		src.killer = M.name
		M << "\white Zenni +[src.zenni]"
		M << "\white EXP +[bonus_exp]"
		spawn() M.Level_Up()

		if(src.race == "Green Saibaman")
			M.green_kills ++

		if(src.race == "Henchman")
			M.thug_kills ++

		if(src.race == "Namekian Warrior")
			M.namek_kills ++

		M.kills ++
		del(src)
		..()

mob/Saga/BigKiDeathCheck(mob/PC/M)
	if(src.powerlevel <= 0)

		var/bonus_exp = src.tnl
		if("minor_exp_buff" in M.buffs)
			bonus_exp += bonus_exp * 0.05
		if("exp_buff" in M.buffs)
			bonus_exp += bonus_exp * 0.25
		M.exp += bonus_exp
		M.zenni += src.zenni
		M << "\white Zenni +[src.zenni]"
		M << "\white EXP +[bonus_exp]"
		spawn() M.Level_Up()

		if(raditz_saga_on)
			raditz_saga ++

		if(vegeta_saga_on)
			vegeta_saga ++

		if(ginyu_saga_on)
			ginyu_saga ++

		if(frieza_saga_on)
			frieza_saga ++

		if(android_saga_on)
			android_saga ++

		if(cell_saga_on)
			cell_saga ++

		if(majin_saga_on)
			majin_saga ++

/*		if(goku_piccolo_saga_on)
			goku_piccolo_saga ++

		if(z_force_saga_on)
			z_force_saga ++

		if(z_force_saga2_on)
			z_force_saga2 ++

		if(z_force_2_saga_on)
			z_force_2_saga ++

		if(z_force2_2_saga_on)
			z_force2_2_saga ++

		if(super_piccolo_saga_on)
			super_piccolo_saga ++

		if(super_goku_saga_on)
			super_goku_saga ++

		if(ssj_goku_saga2_on)
			ssj_goku_saga2 ++

		if(trunks_saga_on)
			trunks_saga ++

		if(ssj_goku_2_saga_on)
			ssj_goku_2_saga ++

		if(ssj_vegeta_saga_on)
			ssj_vegeta_saga ++

		if(super_piccolo_2_saga_on)
			super_piccolo_2_saga ++

		if(ascended_vegeta_saga_on)
			ascended_vegeta_saga ++

		if(ascended_trunks_saga_on)
			ascended_trunks_saga ++

		if(z_fighters_3_saga_on)
			z_fighters_3_saga ++

		if(ssj_2_gohan_on)
			ssj_2_gohan ++

		if(ssj_2_gohan_2_saga_on)
			ssj_2_gohan_2_saga ++

		if(ssj_2_goku_saga_on)
			ssj_2_goku_saga ++

		if(gotenks_saga_on)
			gotenks_saga ++

		if(mystic_gohan_saga_on)
			mystic_gohan_saga ++

		if(vegito_saga_on)
			vegito_saga ++

		if(goku_vegeta_kais_saga_on)
			goku_vegeta_kais_saga ++
*/
		del(src)
		..()

mob/PC/BigKiDeathCheck(mob/M)
	if(src.powerlevel <= 0)
		new/obj/techs/Overlays/Crater_Center(src.loc)

		if(src.level >= M.level / 4)
			if(M.combat_points < M.combat_points_max)
				M.combat_points += 50
				M << "Your Combat Points have increased by: \red 50"

		if(M.karma == src.karma)
			M.karma_rating -= 0.5
		else
			M.karma_rating += 0.5

		if(M.karma_rating < 0)
			if(M.karma == "Good")
				M.karma = "Evil"
				M << "<I>You feel an Evil inside of you begin to awaken..."
				M.karma_rating = 0
			else
				M.karma = "Good"
				M << "<I>You feel the Good inside of you begin to awaken..."
				M.karma_rating = 0

		spawn() src.Power_Redefine()

		if(src.race == "Majin")
			if(!src.regen_dead)
				src.icon_state = "Dead"
				src.frozen = 1
				src.boxing = 0
				src.focus_boxing = 0
				src.doing = 1
				src.density = 1
				src.attack_lock = 1
				src.ki_lock = 1
				src.it_lock = 1
				src.regen_dead = 1
				src.powerlevel = 0
				src.KO = 0
				src.rage = 0
				src.sight &= ~BLIND
				M.kills += 1
			else
				src.buku = 0
				src.rest = 0
				src.frozen = 0
				src.boxing = 0
				src.focus_boxing = 0
				src.doing = 0
				src.icon_state = ""
				src.density = 1
				src.loc = locate(55,6,3)
				src.attack_lock = 0
				src.ki_lock = 0
				src.dead = 1
				src.it_lock = 0
				src.it_blocked = 0
				src.regen_dead = 0
				src.powerlevel = 50
				src.KO = 0
				src.rage = 0
				src.sight &= ~BLIND
				src.overlays += src.halo
				src.deaths += 1
				M.kills += 1
				src << "Your body was completely Destroyed!"
				world << "<FONT color = red>Battle Information:<FONT color = White> [src] died at the hands of [M]!"

		else
			src.buku = 0
			src.dead = 1
			src.rest = 0
			src.frozen = 0
			src.boxing = 0
			src.focus_boxing = 0
			src.doing = 0
			src.icon_state = ""
			src.density = 1
			src.loc = locate(55,6,3)
			src.attack_lock = 0
			src.ki_lock = 0
			src.it_lock = 0
			src.buku_lock = 0
			src.it_blocked = 0
			src.powerlevel = 50
			src.KO = 0
			src.rage = 0
			src.sight &= ~BLIND
			src.overlays += src.halo
			src.deaths += 1
			M.kills += 1
			world << "<FONT color = red>Battle Information:<FONT color = White> [src] died at the hands of [M]!"

		for(var/mob/PC/M2 in view(12))
			if(!M2)return
			if(M2.race == "Saiyan" || M2.race == "Half Saiyan")
				M2.witness_deaths ++
				spawn() M2.Rage_Unleash()
			if(M2 == M)continue
			M2 << "\red You feel your Rage Grow..."
			M2.rage += round(rand(20,50))
			if(M2.rage >= 100)
				M2.rage = 100

 /***************\
|*****************|
|**ABSORB  DEATH**|
|*****************|
 \***************/

mob/proc/AbsorbDeathCheck()
	if(src.powerlevel <= 0)
		..()

mob/Monster/AbsorbDeathCheck(mob/PC/M)
	if(src.powerlevel <= 0)
		new/obj/techs/Overlays/Crater_Center(src.loc)

		var/bonus_exp = src.tnl
		if("minor_exp_buff" in M.buffs)
			bonus_exp += bonus_exp * 0.05
		if("exp_buff" in M.buffs)
			bonus_exp += bonus_exp * 0.25
		M.exp += bonus_exp
		M.zenni += src.zenni
		src.killer = M.name
		M << "\white Zenni +[src.zenni]"
		M << "\white EXP +[bonus_exp]"
		spawn() M.Level_Up()

		if(src.race == "Green Saibaman")
			M.green_kills ++

		if(src.race == "Henchman")
			M.thug_kills ++

		if(src.race == "Namekian Warrior")
			M.namek_kills ++

		M.kills ++
		del(src)
		..()

mob/Saga/AbsorbDeathCheck(mob/PC/M)
	if(src.powerlevel <= 0)
		var/bonus_exp = src.tnl
		if("minor_exp_buff" in M.buffs)
			bonus_exp += bonus_exp * 0.05
		if("exp_buff" in M.buffs)
			bonus_exp += bonus_exp * 0.25
		M.exp += bonus_exp
		M.zenni += src.zenni
		M << "\white Zenni +[src.zenni]"
		M << "\white EXP +[bonus_exp]"
		spawn() M.Level_Up()

		if(raditz_saga_on)
			raditz_saga ++

		if(vegeta_saga_on)
			vegeta_saga ++

		if(ginyu_saga_on)
			ginyu_saga ++

		if(frieza_saga_on)
			frieza_saga ++

		if(android_saga_on)
			android_saga ++

		if(cell_saga_on)
			cell_saga ++

		if(majin_saga_on)
			majin_saga ++

/*		if(goku_piccolo_saga_on)
			goku_piccolo_saga ++

		if(z_force_saga_on)
			z_force_saga ++

		if(z_force_saga2_on)
			z_force_saga2 ++

		if(z_force_2_saga_on)
			z_force_2_saga ++

		if(z_force2_2_saga_on)
			z_force2_2_saga ++

		if(super_piccolo_saga_on)
			super_piccolo_saga ++

		if(super_goku_saga_on)
			super_goku_saga ++

		if(ssj_goku_saga2_on)
			ssj_goku_saga2 ++

		if(trunks_saga_on)
			trunks_saga ++

		if(ssj_goku_2_saga_on)
			ssj_goku_2_saga ++

		if(ssj_vegeta_saga_on)
			ssj_vegeta_saga ++

		if(super_piccolo_2_saga_on)
			super_piccolo_2_saga ++

		if(ascended_vegeta_saga_on)
			ascended_vegeta_saga ++

		if(ascended_trunks_saga_on)
			ascended_trunks_saga ++

		if(z_fighters_3_saga_on)
			z_fighters_3_saga ++

		if(ssj_2_gohan_on)
			ssj_2_gohan ++

		if(ssj_2_gohan_2_saga_on)
			ssj_2_gohan_2_saga ++

		if(ssj_2_goku_saga_on)
			ssj_2_goku_saga ++

		if(gotenks_saga_on)
			gotenks_saga ++

		if(mystic_gohan_saga_on)
			mystic_gohan_saga ++

		if(vegito_saga_on)
			vegito_saga ++

		if(goku_vegeta_kais_saga_on)
			goku_vegeta_kais_saga ++
*/
		del(src)
		..()

mob/PC/AbsorbDeathCheck(mob/M)
	if(src.powerlevel <= 0)

		if(src.level >= M.level / 4)
			if(M.combat_points < M.combat_points_max)
				M.combat_points += 50
				M << "Your Combat Points have increased by: \red 50"

		if(M.karma == src.karma)
			M.karma_rating -= 0.5
		else
			M.karma_rating += 0.5

		if(M.karma_rating < 0)
			if(M.karma == "Good")
				M << "<I>You feel an Evil inside of you begin to awaken..."
				M.karma = "Evil"
				M.karma_rating = 0
			else
				M << "<I>You feel the Good inside of you begin to awaken..."
				M.karma = "Good"
				M.karma_rating = 0

		spawn() src.Power_Redefine()

		src.loc = locate(55,6,3)

		if(src.race == "Majin")
			if(!src.regen_dead)
				src.rest = 0
				src.frozen = 0
				src.boxing = 0
				src.focus_boxing = 0
				src.doing = 0
				src.icon_state = ""
				src.density = 1
				src.attack_lock = 0
				src.ki_lock = 0
				src.it_lock = 0
				src.buku_lock = 0
				src.it_blocked = 0
				src.regen_dead = 0
				src.powerlevel = 50
				src.KO = 0
				src.rage = 0
				src.sight &= ~BLIND
				src.overlays += src.halo
				src.deaths += 1
				M.kills += 1
				src << "Your body was Absorbed!"
				world << "<FONT color = red>Battle Information:<FONT color = White> [src] was Absorbed by [M]!"

		else
			src.buku = 0
			src.dead = 1
			src.rest = 0
			src.frozen = 0
			src.boxing = 0
			src.focus_boxing = 0
			src.doing = 0
			src.icon_state = ""
			src.density = 1
			src.attack_lock = 0
			src.ki_lock = 0
			src.it_lock = 0
			src.buku_lock = 0
			src.it_blocked = 0
			src.powerlevel = 50
			src.KO = 0
			src.rage = 0
			src.sight &= ~BLIND
			src.overlays += src.halo
			src.deaths += 1
			M.kills += 1
			world << "<FONT color = red>Battle Information:<FONT color = White> [src] was Absorbed by [M]!"

		for(var/mob/PC/M2 in view(8))
			if(!M2)return
			if(M2.race == "Saiyan" || M2.race == "Half Saiyan")
				M2.witness_deaths ++
				spawn() M2.Rage_Unleash()
			if(M2 == M)continue
			M2 << "\red You feel your Rage Grow..."
			M2.rage += round(rand(20,50))
			if(M2.rage >= 100)
				M2.rage = 100


mob
	proc
		GRAVITYDeath()
			if(src.powerlevel <= 0)

				src.grav = 0

				world << "<FONT color = #F3982D>Training Information:<FONT color = White> [src] died whilst Gravity Training!"

				spawn() src.Power_Redefine()

				if(src.race == "Majin")
					src.buku = 0
					src.rest = 0
					src.frozen = 0
					src.boxing = 0
					src.focus_boxing = 0
					src.doing = 0
					src.icon_state = ""
					src.density = 1
					src.loc = locate(55,6,3)
					src.attack_lock = 0
					src.ki_lock = 0
					src.it_lock = 0
					src.buku_lock = 0
					src.it_blocked = 0
					src.dead = 1
					src.powerlevel = 50
					src.KO = 0
					src.rage = 0
					src.sight &= ~BLIND
					src.overlays += src.halo
					src.deaths += 1
					src << "Your body was completely Crushed!"
				else
					src.buku = 0
					src.rest = 0
					src.frozen = 0
					src.boxing = 0
					src.focus_boxing = 0
					src.doing = 0
					src.icon_state = ""
					src.density = 1
					src.loc = locate(55,6,3)
					src.attack_lock = 0
					src.ki_lock = 0
					src.it_lock = 0
					src.buku_lock = 0
					src.it_blocked = 0
					src.dead = 1
					src.powerlevel = 50
					src.KO = 0
					src.rage = 0
					src.sight &= ~BLIND
					src.overlays += src.halo
					src.deaths += 1