mob/PC
	verb/Ki_Blast()
		set category = "Techniques"

		if(src.doing)
			src << "You are already doing something!"
			return

		if(src.buku)
			return

		if(src.dead)
			return

		if(src.ki_lock)
			src << "Cannot use this Technique at his time"
			return

		if(!src.pk)
			usr << "You are not a Combatant!"
			return

		for(var/turf/Floors/Safe_Zone/S in view(6))
			if(S in view(8))
				usr << "They are in a Safe Zone!"
				return

		spawn() Ki_Blast_Shoot()
		src.afk_time = 0

mob
	proc
		Ki_Blast_Shoot()
			var/obj/H = new/obj/Ki_Blast
			var/ki_damage = round(((usr.ki_skill / usr.ki_skill_max) * usr.level) + usr.powerlevel_max * 0.05)
			var/ki_cost = round(src.ki_max * 0.05)

			if(src.ki >= ki_cost)
				if(!src.doing)
					src.doing = 1
					src.ki -= ki_cost
					view(6) << "<font color = white>[src]:</font> HYA!!!"
					spawn(5) src.doing = 0
					spawn(5) src.frozen = 0
					H.dir = src.dir
					H.loc = src.loc

					while(H)
						step(H,H.dir)
						if(!H)break
						var/turf/T = H.loc
						if(T.density)
							del(H)
							break
						for(var/mob/M as mob in T)

							if(M == src)
								continue

							if(!M.dead && !M.safe && M.pk)
								M.powerlevel -= round(ki_damage)
								M << "\red [usr.name]'s Ki Blast slams into you"
								M.SmallKiDeathCheck(src)
								src.doing = 0
								src.frozen = 0
								return
							del(H)
						sleep(1)

obj/Ki_Blast
	icon = 'Ki Attack.dmi'