mob/var/boxing = 0
mob/var/boxing_delay = 0

mob/PC/verb/Train()
	set category = "Training"

	if(src.boxing_delay)
		src << "You must wait a moment before Training again!"
		return

	if(src.fatigue >= src.fatigue_max)
		src << "You are too exhausted to Train"
		return

	if(src.boxing)
		src.icon_state = ""
		src.boxing = 0
		src.frozen = 0
		src.doing = 0
		src << "You stop training"
		spawn(25) src.boxing_delay = 0
		src.afk_time = 0
		return

	if(src.doing)
		return

	if(!src.boxing)
		src.boxing_delay = 1
		src.icon_state = "spar fury"
		src.boxing = 1
		src.doing = 1
		src.frozen = 1
		src << "You begin to train yourself"
		spawn(25) src.boxing_delay = 0
		spawn(5) src.Box_Gain()
		src.afk_time = 0
		return

mob/proc/Box_Gain()

	if(!src.boxing)
		return

	if(src.fatigue >= src.fatigue_max)
		src << "You fall to your knees gasping for air"
		src.fatigue = src.fatigue_max
		src.boxing = 0
		src.frozen = 0
		src.doing = 0
		src.icon_state = ""
		spawn(35) src.boxing_delay = 0
		return

	if(src.powerlevel <= 0)
		src << "You fall to your knees clutching your chest"
		src.powerlevel = 5
		src.boxing = 0
		src.frozen = 0
		src.doing = 0
		src.icon_state = ""
		spawn(35) src.boxing_delay = 0
		return


	if(src.fatigue >= (src.fatigue_max * 0.95))
		var/sweat = rand(1,4)
		if(sweat)
			src << "Beads of sweat roll down your body"

	src.fatigue += rand(0,(src.level * 0.05))

	if(src.level > 30)
		src.powerlevel -= rand(0,5)

	sleep(12)

	if(!src.boxing)
		return

	var/bonus_exp = round(rand(4,10) + src.level)

	for(var/obj/Gravity_Room/Gravity_Control/C in view(24))
		if(C.grav > 0)
			bonus_exp += C.grav / 4

	for(var/obj/Gravity_Room/Guild_Gravity_Control/C2 in view(24))
		if(C2.grav > 0)
			bonus_exp += C2.grav / 3

	if("exp_buff" in src.buffs)
		bonus_exp = bonus_exp * 0.25

	src.exp += bonus_exp

	for(var/obj/Gravity_Room/Gravity_Control/C in view(24))
		src.powerlevel -= C.grav / 6
		src.GRAVITYDeath()

	for(var/obj/Gravity_Room/Guild_Gravity_Control/C2 in view(24))
		src.powerlevel -= C2.grav / 6
		src.GRAVITYDeath()

	var/zenny_prob = rand(1,50)

	if(prob(zenny_prob))
		src.zenni += rand(1,10)

	spawn(5) src.Level_Up()
	spawn(15) src.Box_Gain()
	return



