mob/Guild_Verbs
	verb
		Guild_Chat(T as text)
			set category = "Guild"
			set desc = "Chat to the Guild"

			if(src.guild_mute)
				spawn() alert("You have been Guild Muted!")
				return

			if(lentext(T) > 500)
				spawn() alert("Message must be less than 500 Characters!")
				return

			if(!T)
				spawn() alert("Your message may not be blank.")
				return

			for(var/client/C)
				if(C.mob)
					var/mob/X = C.mob
					if(X.guild_name == src.guild_name)
						if(X.gooc_on)
							X << {"\yellow [src.guild_rank] | [src.name] GuildSays: [html_encode(T)]"}

			src.guild_say_delay ++
			sleep(100)
			src.guild_say_delay = 0

		Guild_Who()
			set category = "Guild"
			var/count = 0
			src << "-------------------------------"
			for(var/client/C)
				if(C.mob)
					var/mob/X = C.mob
					if(X.guild_name == src.guild_name)
						count += 1
						src << "\white[X]: [X.guild_rank]"
			src << "Guild Members Online: [count]"
			src << "-------------------------------"

		Guild_Leave()
			set category = "Guild"
			switch(alert("Are you sure you wish to leave the Guild [src.guild_name]?","Guild Leave","Yes","No"))

				if("Yes")
					for(var/client/C)
						if(C.mob)
							var/mob/X = C.mob
							if(X.guild_name == src.guild_name)
								X << "<font color = #BB0EDA>Guild Information:</font> [src] has left the Guild!"

					src.guild_name = ""
					src.guild_name_html = ""
					src.guild_rank = ""
					src.in_guild = 0
					src.Check_Verbs()

				if("No")
					return

mob/proc/Check_Verbs()
	if(src.in_guild)
		src.verbs += typesof(/mob/Guild_Verbs/verb/)
	else
		src.verbs -= typesof(/mob/Guild_Verbs/verb/)