obj/Equipment/Consumable

	Dragon_Radar
		icon = 'Dragon Radar.dmi'
		icon_state = "DBRadar"

		Click()
			if(usr.z == 1)
				if(usr.dbrad == 0)
					usr.dbrad = 1
					var/obj/O = new/obj/dragonradar/hud/s0(usr.client)
					O.screen_loc = "1:16,10:10"
					O.layer = 50
					usr.client.screen += O
					usr.client.radar = O
					..()


					var/obj/O1 = new/obj/dragonradar/hud/s1(usr.client)
					O1.screen_loc = "1,10"
					O1.layer = 49
					usr.client.screen += O1
					..()

					var/obj/O2 = new/obj/dragonradar/hud/s2(usr.client)
					O2.screen_loc = "2,10"
					O2.layer = 49
					usr.client.screen += O2
					..()


					var/obj/O3 = new/obj/dragonradar/hud/s3(usr.client)
					O3.screen_loc = "1,11"
					O3.layer = 49
					usr.client.screen += O3
					..()

					var/obj/O4 = new/obj/dragonradar/hud/s4(usr.client)
					O4.screen_loc = "2,11"
					O4.layer = 49
					usr.client.screen += O4
					..()

				else
					for(var/obj/dragonradar/hud/H in usr.client.screen)
						del(H)
					usr.dbrad = 0
			else
				usr << "This Radar only works on Earth!"
				return

		verb
			Examine()
				set category = null
				var/examine_dragon = "<body bgcolor=#000000 text=#FFFFFF><table border=0 cellspacing=1 width=250 id=AutoNumber1 height=210><tr><td width=273 colspan=2 height=18><font face=Tahoma color=#FF0000>Dragon Radar</font></b></td></tr><tr><td width=96 height=12><font size=1 color=red face=Tahoma>Condition:</font></b></td><td width=170 height=12><font size=1><font face=Tahoma>[condition]</font></b></font><font size=1 face=Tahoma> / [condition_max]</font></b></td></tr><tr><td width=96 height=12><font face=Tahoma size=1 color=#FF0000>Trait</font><font size=1 color=red face=Tahoma>:</font></b></td><td width=174 height=12><font face=Tahoma size=1>Detect Dragonballs</font></b></td></tr><tr><td width=96 height=12><font face=Tahoma size=1 color=#FF0000>Owner:</font></b></td><td width=174 height=12><font face=Tahoma size=1>[usr]</font></b></td></tr><tr><td width=273 colspan=2 height=48 style=font-family: Tahoma; font-size: 8pt; font-weight: bold><font size=1 face=Tahoma>Capable of detecting all the Dragonballs on earth. The front piece has a display that shows where and how far away you are from the nearest Dragonball(s). You can also set the range as to how much area you want to cover. The top button is used as an on and off switch.&nbsp;</font></b></td></tr></table>"
				usr << browse(examine_dragon,"window=Dragon Radar;size=300x275;border=0;can_resize=0; can_minimize=0;")

			Pick_Up()
				set src in oview(0)
				set category = null
				if(Move(usr))
					usr << "You have picked up the: <u>[src]</u>."
					usr.inven_min += 1
				else
					usr << "You are unable to pick up the: <u>[src]</u>."

			Drop()
				set category = null
				if(!src.equiped)
					src.loc = usr.loc
					src.icon_state = "DBRadar"
					usr << "You have dropped the: <u>[src]</u>."
					usr.inven_min -= 1
				else
					usr << "You are unable to drop: <u>[src.name]</u>, it's already equipped."


proc/Update_Radar()
	for(var/client/C)
		if(C.radar)
			var/icon/R = icon('Dragon Radar.dmi',"rad")

			R.DrawBox(rgb(255,255,255), 17, 17-3, 17, 17+3)
			R.DrawBox(rgb(255,255,255), 17-3, 17, 17+3, 17)
			for(var/obj/Dragonballs/O in world)
				if(get_dist(C.mob,O) < 20 && O.icon == 'dragonball.dmi')
					var/x = 16-(C.mob.x - O.x)+1
					var/y = 16-(C.mob.y - O.y)+1
					R.DrawBox(rgb(255,220,60), x-1, y-1, x+1, y+1)
				if(get_dist(C.mob,O) >= 16 && O.icon == 'dragonball.dmi')
					if(O.y >= C.mob.y +20)
						if(O.x >= C.mob.x +20) // up right
							if(get_dist(C.mob,O) > 20)
								R.DrawBox(rgb(255,0,60), 27, 30)
								R.DrawBox(rgb(255,0,60), 28, 29)
								R.DrawBox(rgb(255,0,60), 29, 28)
								R.DrawBox(rgb(255,0,60), 30, 27)

						if(O.x <= C.mob.x -20) //up left
							if(get_dist(C.mob,O) > 20)
								R.DrawBox(rgb(255,0,60), 6, 30)
								R.DrawBox(rgb(255,0,60), 5, 29)
								R.DrawBox(rgb(255,0,60), 4, 28)
								R.DrawBox(rgb(255,0,60), 3, 27)


					if(O.y <= C.mob.y -20)
						if(O.x >= C.mob.x +20) // down right
							if(get_dist(C.mob,O) > 20)
								R.DrawBox(rgb(255,0,60), 30, 6)
								R.DrawBox(rgb(255,0,60), 29, 5)
								R.DrawBox(rgb(255,0,60), 28, 4)
								R.DrawBox(rgb(255,0,60), 27, 3)



						if(O.x <= C.mob.x -20) // down left
							if(get_dist(C.mob,O) > 20)
								R.DrawBox(rgb(255,0,60), 3, 6)
								R.DrawBox(rgb(255,0,60), 4, 5)
								R.DrawBox(rgb(255,0,60), 5, 4)
								R.DrawBox(rgb(255,0,60), 6, 3)


					if(O.y >= C.mob.y && O.y <= C.mob.y +10)
						if(O.x >= C.mob.x) //right

							R.DrawBox(rgb(255,0,60), 31, 13 ,31,20)

						if(O.x <= C.mob.x) // left

							R.DrawBox(rgb(255,0,60), 2, 13 ,2,20)


					if(O.x >= C.mob.x && O.x <= C.mob.x +10)
						if(O.y >= C.mob.y) //up

							R.DrawBox(rgb(255,0,60), 13, 31 ,20,31)



						if(O.y <= C.mob.y) //down

							R.DrawBox(rgb(255,0,60), 13, 2 ,20,2)



			C.radar.icon = R



	spawn(5)
		Update_Radar()


obj/Dragonballs
	db


obj/dragonradar/hud
	icon = 'Dragon Radar.dmi'
	s0
		icon_state = "rad"
	s1
		icon_state = "1"
	s2
		icon_state = "2"
	s3
		icon_state = "3"
	s4
		icon_state = "4"

obj/dragonradar/huddir
	s0


mob/var
	dbrad = 0


client
	var
		obj/dragonradar/radar