mob/var/level_tp = 0
mob/var/level_chance = 0

mob/proc/Level_Up()

	if(src.exp >= src.tnl)

		var/power_multi = 2
		var/ki_multi = 2
		var/str_multi = 1.5
		var/def_multi = 1.5

		if(src.race == "Saiyan")
			power_multi = 4
			str_multi = 3.5

		if(src.race == "Half Saiyan")
			power_multi = 3
			str_multi = 2.8
			def_multi = 2.2

		if(src.race == "Human")
			power_multi = 2.5
			str_multi = 3
			def_multi = 3

		if(src.race == "Changling")
			power_multi = 3.5
			str_multi = 4.5

		if(src.race == "Tuffle")
			power_multi = 3
			str_multi = 2.5
			def_multi = 2.5

		if(src.race == "Bio-Android")
			power_multi = 2.5
			ki_multi = 2.5
			str_multi = 2.5
			def_multi = 2.5

		if(src.race == "Majin")
			power_multi = 3
			str_multi = 3.5

		if(src.race == "Namek")
			power_multi = 2.2
			ki_multi = 3
			def_multi = 4

		var/power_gain 	= round(25 * ((src.level * power_multi) + rand(10,50)))
		var/ki_gain 	= round(25 * ((src.level * ki_multi) + rand(10,50)))
		var/str_gain 	= round(4 * ((src.level * str_multi) + rand(2,10)))
		var/def_gain 	= round(4 * ((src.level * def_multi) + rand(2,10)))

		src.exp -= src.tnl
		src.level ++
		src.level_tp ++
		src.level_chance ++

		src << "<center><I>------------------------------</I></center>"
		src << "<center><font color = #FBEC5D> Level Up: \white [src] <font color = #FBEC5D> Level: \white [src.level] <font color = #FBEC5D></font></center>"

		if(power_gain >=1)
			src << "<center><I>Your stored energy explodes as your power level grows \white +[power_gain]</center>"

		if(ki_gain >=1)
			src << "<center><I>Your stored energy explodes as your ki grows \white +[ki_gain]</center>"

		if(str_gain >= 1)
			src << "<center><I>Your stored energy explodes as your strength grows \white +[str_gain]</center>"

		if(def_gain >= 1)
			src << "<center><I>Your stored energy explodes as your defense grows \white +[def_gain]</center>"

		if(src.level_tp >= 15)
			src << "<center><I>Training Points \white +5</center>"
			src.tp += 5
			src.level_tp = 0

		if(src.level_chance >= 15)
			var/chance = rand(1,5)
			var/chance_up = rand(1,2)

			if(chance == 1)
				if(src.block_max < 55)
					src << "<center><I>Chance to Block \white +[chance_up]%</center>"
					src.block += chance_up
					src.block_max += chance_up
					src.level_chance = 0
			if(chance == 2)
				if(src.reflect_max < 55)
					src << "<center><I>Chance to Reflect \white +[chance_up]%</center>"
					src.reflect += chance_up
					src.reflect_max += chance_up
					src.level_chance = 0
			if(chance == 3)
				if(src.dodge_max < 55)
					src << "<center><I>Chance to Dodge \white +[chance_up]%</center>"
					src.dodge += chance_up
					src.dodge_max += chance_up
					src.level_chance = 0
			if(chance == 4)
				if(src.critical_max < 55)
					src << "<center><I>Chance to Critical \white +[chance_up]%</center>"
					src.critical += chance_up
					src.critical_max += chance_up
					src.level_chance = 0
			if(chance == 5)
				if(src.counter_max < 55)
					src << "<center><I>Chance to Counter \white +[chance_up]%</center>"
					src.counter += chance_up
					src.counter_max += chance_up
					src.level_chance = 0
		src << "<center><I>------------------------------</I></center>"


		src.powerlevel_max += power_gain
		src.ki_max += ki_gain
		src.unarmed_max += 5
		src.ki_skill_max  += 5

		src.strength += str_gain
		src.defence += def_gain
		src.strength_max += str_gain
		src.defence_max += def_gain

		if(src.level <= 2)
			src.tnl += 50
		else
			src.tnl =  round((src.level * src.level) * 35)

		if(src.train_chromosome)
			spawn(5) src.Train_SSJ()

		spawn(5) src.Skill_Gain()
		spawn(5) src.Level_Up()

mob
	proc
		Train_SSJ()
			if(!src.gone_ssj && src.level >= 50)
				if(src.race == "Half Saiyan")
					if(src.powerlevel_max >= 85000)
						src.gone_ssj = 1
						src.icon_state = "enrage"

						view(6) << "\white <I>[src.name] feels an uncontrollable rage burning in them as they remember those Saiyan's who have Surpassed them"
						sleep(25)
						view(6) << "\white <I>[src.name] clentchs their fists, as tears well in their eyes. Veins protrude from their hands and forehead as the ground rumbles"
						sleep(25)
						view(6) << "\white [src.name]: I AM THE STRONGEST OF THE SAIYAN'S! NO ONE SHALL SURPASS ME!!"
						src.icon_state = ""

						src.contents += new/obj/Transform/Transform
						src.contents += new/obj/Transform/Revert

						src.Half_Saiyan_Trans()
						Explode(new /Effect/BasicBoom(src.loc,1,3))

						sleep(25)

						var/chance = rand(30,60)

						if(prob(chance))
							src << "You are unable to fully control your Super Saiyan state!"
							src.Half_Saiyan_Revert()
				else
					if(src.race == "Saiyan")
						if(src.powerlevel_max >= 100000)
							src.gone_ssj = 1
							src.icon_state = "enrage"

							view(6) << "\white <I>[src.name] feels an uncontrollable rage burning in them as they remember those Saiyan's who have Surpassed them"
							sleep(25)
							view(6) << "\white <I>[src.name] clentchs their fists, as tears well in their eyes. Veins protrude from their hands and forehead as the ground rumbles"
							sleep(25)
							view(6) << "\white [src.name]: I AM THE STRONGEST OF THE SAIYAN'S! NO ONE SHALL SURPASS ME!!"
							src.icon_state = ""

							src.contents += new/obj/Transform/Transform
							src.contents += new/obj/Transform/Revert

							src.Half_Saiyan_Trans()
							Explode(new /Effect/BasicBoom(src.loc,1,3))

							sleep(25)

							var/chance = rand(30,60)

							if(prob(chance))
								src << "You are unable to fully control your Super Saiyan state!"
								src.Saiyan_Revert()

			else
				return