mob/var/kk_quest_start = 0
mob/var/kk_quest_complete = 0
mob/var/kk_quest_training = 0

mob/NPC/

	King_Kai
		name = "{NPC} King Kai"
		icon = 'King Kai.dmi'
		density = 1
		doing = 0
		safe = 1

		powerlevel = 100

		energy_code = 2215368

		New()
			src.CreateName()

		verb/Talk()
			set src in oview(1)
			set category = null

			if(src in view(2))
				if(!usr.kk_quest_start)
					usr << "<font color = white>King Kai:</font> Greetings [usr.name]. I see your quiet a strong warrior. Would you like me to aid your training?"
					sleep(15)
					switch(alert("Begin your Training?","Quest: Warrior's Worth","Yes","Not Yet"))
						if("Yes")
							usr.kk_quest_start = 1
							usr.contents += new/obj/Quests/King_Kai/A_Warriors_Worth
							usr << "<font color = white>King Kai:</font> Good to Hear! I'll teach you a skill called the <font color = red>Kaio Ken</red>, but only if you can prove yourself!"
							usr << "<font color = white>King Kai:</font> If you can Catch Bubbles and Hit Gregory, then I will consider you worth enough."
						else
							usr << "<font color = white>King Kai:</font> Ohh, that's unfortunant to hear"
							return
				else
					if(!usr.kk_quest_complete)
						if(usr.gregory_hit && usr.bubbles_caught)
							usr << "<font color = white>King Kai:</font> Great work! You truely are worthy of such a powerful Technique"
							usr.kk_quest_complete = 1
							usr.learn_kaioken = 1
							usr.verbs += new/mob/learn/verb/Kaioken
							for(var/obj/Quests/King_Kai/A_Warriors_Worth/Q)
								del(Q)
						else
							usr << "<font color = white>King Kai:</font> You still aren't ready, keep Training!"
							return
					else
						var/talk = input("King Kai: What do you need, [usr.name]?","") in list ("I want to be revived","I want to go to Supreme Kai's","Never Mind")

						switch(talk)

							if("Never Mind")
								return

							if("I want to be revived")
								if(!usr.pk)
									usr << "<font color = white>King Kai:</white> I see you are ready to go, let me revive you."
									usr.powerlevel = usr.powerlevel_max
									usr.overlays -= usr.halo
									usr.overlays -= halo
									usr.overlays -= usr.halo
									usr.overlays -= halo
									usr.loc = locate(63,28,1)
									usr.safe = 1
									usr.dead = 0
									sleep(300)
									if(!usr)return
									usr.safe = 0
								else
									usr << "<font color = white>King Kai:</white> I see you are ready to go, let me revive you."
									usr.powerlevel = usr.powerlevel_max
									usr.overlays -= usr.halo
									usr.overlays -= halo
									usr.overlays -= usr.halo
									usr.overlays -= halo
									usr.loc = locate(54,175,1)
									usr.safe = 1
									usr.dead = 0
									sleep(300)
									if(!usr)return
									usr.safe = 0

							if("I want to go to Supreme Kai's")
								usr << "<font color = white>King Kai:</white> Very well"
								usr.loc = locate(135,155,3)
			else
				return